<id>
Sub-Boards for YaBB 2.1
</id>

<version>
1.0.8
</version>

<mod info>
This mod allows one to create sub-boards for YaBB 2.1 release.

Installation:
1) First thing to do is go to your default templates in the Admin Center and save the Display.template file. (On a fresh download the default template has &rsaquo; in the text instead of . Saving the file via the Admin Center will automatically change it.)
2) Save the SubBoard.lng file to the language's designated directory.
3) Install the Sub-Boards_for_Y2-1_1-0-8.mod via BoardMod.exe

To create a sub-board:
1) In the Manage Boards section, edit or add a board.
2) Under the Location option, choose a parent board for your currently edited board, and Save.

To reorder the subboards:
1) Click the "Reorder Sub-boards" link in the Manage Boards section.
2) Rearrange the boards in the order you choose, and Save.

Special thanks to:
Mick for SubBoard.lng (German translation)

Version History:
1.0.8 - Fixed last post, thread count, message count and new posts icon to be compatible with board restrictions. Implemeted mod in Mark All As Read feature on Board and Category indexes.
1.0.7 - Fixed problem with new posts icon. Fixed problem of parent boards not showing in message index. Also, changed board indexes to show last post and total thread/message count for board and all it's subboards.
1.0.6 - Reduced amount of times the forum.totals file is opened. Fixed the high number of boards loaded in debug mode. New posts icon now works on collapsed categories.
1.0.5 - Fixed sub-board stat error. Added Last Sub-Board Post to boardindexes.
1.0.4 - Implemented mod into Recent Post lists (both in the profile and Info Center) and Search feature. Added board stats (total topics/messages) to boardindexes and Info Center. Included category/board access rights in mod.
1.0.3 - Fixed major bug that occurs when uninstalling the mod.
1.0.2 - Fixed bugs: category name not visible after board reorder; wrong board name in title bar; and wrong mods and modgroups displayed under navigation bar.
1.0.1 - Fixed compatibility with Message Index with Board Picture YaBB2 mod. Added German language file.
1.0 - First release.
</mod info>

<author>
BRO_co03
</author>

<homepage>
http://broco03.tk
</homepage>

<edit file>
Admin/ManageBoards.pl
</edit file>

<search for>
require "$vardir/membergroups.txt";
</search for>

<add before>
LoadLanguage("SubBoard");
</add before>

<search for>
				$boardname =~ s/\&quot\;/&#34;/g;
				&ToChars($boardname);
				$descr = ${$uid.$curboard}{'description'};
				$descr =~ s~\<br />~\n~g;
				my $bicon = "";
				if (${$uid.$curboard}{'ann'} == 1)  { $bicon = qq~ <img src="$imagesdir/ann.gif" alt="$admin_txt{'64g'}" border="0" />~; }
				if (${$uid.$curboard}{'rbin'} == 1) { $bicon = qq~ <img src="$imagesdir/admin_rem.gif" alt="$admin_txt{'64i'}" border="0" />~; }
				$convertstr = $descr;
				$convertcut = 60;
				&CountChars;
				my $descr = $convertstr;
				&ToChars($descr);
				if ($cliped) { $descr .= "..."; }
				$yymain .= qq~
  <tr>
    <td class="windowbg" width="25%" align="left">$boardname</td>
    <td class="windowbg" width="65%" align="left">$descr</td>
    <td class="windowbg" width="5%" align="center">$bicon</td>
    <td class="titlebg" width="5%" align="center"><input type="checkbox" name="$curboard" value="1" /></td>
  </tr>
~;
</search for>

<replace>
				$boardname =~ s/\&quot\;/&#34;/g;
				&ToChars($boardname);
				$descr = ${$uid.$curboard}{'description'};
				$descr =~ s~\<br />~\n~g;
				my $bicon = "";
				if (${$uid.$curboard}{'ann'} == 1)  { $bicon = qq~ <img src="$imagesdir/ann.gif" alt="$admin_txt{'64g'}" border="0" />~; }
				if (${$uid.$curboard}{'rbin'} == 1) { $bicon = qq~ <img src="$imagesdir/admin_rem.gif" alt="$admin_txt{'64i'}" border="0" />~; }
				$convertstr = $descr;
				$convertcut = 60;
				&CountChars;
				my $descr = $convertstr;
				&ToChars($descr);
				if ($cliped) { $descr .= "..."; }
				if ($sboard{"$curboard"} ne "") {
					$reordersubs = qq~<br />(<a href="$adminurl?action=reorderboards;location=board;item=$curboard">$subboard_txt{'1'}</a>)~;
				} else { $reordersubs = ""; }
				$yymain .= qq~
  <tr>
    <td class="windowbg" width="25%" align="left">$boardname$reordersubs</td>
    <td class="windowbg" width="65%" align="left">$descr</td>
    <td class="windowbg" width="5%" align="center">$bicon</td>
    <td class="titlebg" width="5%" align="center"><input type="checkbox" name="$curboard" value="1" /></td>
  </tr>
~;
				if ($sboard{"$curboard"} ne "") {
					$subboards = $sboard{"$curboard"};
					$level = 1;
					&CalcSubBoards_ManageBoards2;
				}
</replace>

<search for>
	$i = 1;
	foreach $thiscat (@categoryorder) {
		(@theboards) = split(/\,/, $cat{$thiscat});
		for ($z = 0; $z < @theboards; $z++) {
			for ($j = 0; $j < @editboards; $j++) {
				if ($editboards[$j] eq $theboards[$z]) {
					$editbrd[$i] = $theboards[$z];
					$i++;
				}
			}
		}
	}
	if    ($FORM{'baction'} eq "edit")  { &AddBoards(@editbrd); }
	elsif ($FORM{'baction'} eq "delme") {
</search for>

<replace>
	$i = 1;
	foreach $thiscat (@categoryorder) {
		(@theboards) = split(/\,/, $cat{$thiscat});
		@fullbrdlist = @theboards;
		foreach $brdlist (@theboards) {
			$level = 1;
			if ($sboard{$brdlist} ne "") {
				$sboards = $sboard{"$brdlist"};
				$level++;
				&CalcSubBoards_ManageBoards3;
			}
		}
		for ($z = 0; $z < @fullbrdlist; $z++) {
			for ($j = 0; $j < @editboards; $j++) {
				if ($editboards[$j] eq $fullbrdlist[$z]) {
					$editbrd[$i] = $fullbrdlist[$z];
					$i++;
				}
			}
		}
	}
	if    ($FORM{'baction'} eq "edit")  { &AddBoards(@editbrd); }
	elsif ($FORM{'baction'} eq "delme") {
</replace>

<search for>
		foreach $board (@editboards) {
			if ($board eq "") { next; }

			# Remove Board form category it belongs to
			$category = ${$uid.$board}{'cat'};
			unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
			(@bdlist) = split(/\,/, $cat{"$category"});
			$c = 0;
			foreach $bd (@bdlist) {
				if ($bd eq $board) { splice(@bdlist, $c, 1); last; }
				$c++;
			}
			my @brdlist = &undupe(@bdlist);
			$boardlist = join(',', @brdlist);
			$cat{"$category"} = "$boardlist";
			delete $board{"$board"};
			&Write_ForumMaster;
			$yymain .= qq~$admin_txt{'55'}$board <br />~;
		}

		# Actual deleting
		$editboards = join(',', @editboards);
		&DeleteBoards($editboards);
</search for>

<replace>
		@delboards = ();
		foreach $board (@editboards) {
			if ($board eq "") { next; }
			if ($sboard{"$board"} ne "") {
				$yymain .= qq~$subboard_txt{'8'} $board $subboard_txt{'9'}<br />~;
				next;
			}

			if ($pboard{"$board"} eq "") {
				# Remove Board form category it belongs to
				$category = ${$uid.$board}{'cat'};
				unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
				(@bdlist) = split(/\,/, $cat{"$category"});
				$c = 0;
				foreach $bd (@bdlist) {
					if ($bd eq $board) { splice(@bdlist, $c, 1); last; }
					$c++;
				}
				my @brdlist = &undupe(@bdlist);
				$boardlist = join(',', @brdlist);
				$cat{"$category"} = "$boardlist";
			} else {
				# Remove Sub-board from parent board it belongs to
				@parents = split(/\|/, $pboard{"$board"});
				$parent = $parents[-1];
				unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
				(@sbdlist) = split(/\,/, $sboard{"$parent"});
				$b = 0;
				foreach $sbd (@sbdlist) {
					if ($sbd eq $board) { splice(@sbdlist, $b, 1); last; }
					$b++;
				}
				my @sbrdlist = &undupe(@sbdlist);
				$sboardlist = join(',', @sbrdlist);
				$sboard{"$parent"} = "$sboardlist";

				# Remove it from all parents' %sblist
				foreach $parent (@parents) {
					(@subboardlist) = split(/\,/, $sblist{"$parent"});
					$b = 0;
					foreach $sbd (@subboardlist) {
						if ($sbd eq $board) { splice(@subboardlist, $b, 1); last; }
						$b++;
					}
					my @sbrdlist = &undupe(@subboardlist);
					$sboardlist = join(',', @sbrdlist);
					$sblist{"$parent"} = "$sboardlist";
				}
			}
			# Remove it from the %catbdlist
			(@cbdlist) = split(/\,/, $catbdlist{"$category"});
			$c = 0;
			foreach $cbd (@cbdlist) {
				if ($cbd eq $board) { splice(@cbdlist, $c, 1); last; }
				$c++;
			}
			my @cbrdlist = &undupe(@cbdlist);
			$cboardlist = join(',', @cbrdlist);
			$catbdlist{"$category"} = "$cboardlist";

			delete $board{"$board"};
			delete $pboard{"$board"};
			delete $sboard{"$board"};
			delete $sblist{"$board"};
			&Write_ForumMaster;
			$yymain .= qq~$admin_txt{'55'}$board <br />~;
			push(@delboards, "$board");
		}

		# Actual deleting
		$editboards = join(',', @delboards);
		&DeleteBoards($editboards);
</replace>

<search for>
		foreach $catid (@categoryorder) {
			$boardlist = $cat{$catid};
			(@bdlist) = split(/\,/, $boardlist);
			($curcatname, $catperms) = split(/\|/, $catinfo{"$catid"});
			my $boardcat = ${$uid.$editboards[$i]}{'cat'};
			if ($INFO{"action"} eq "boardscreen") {
				if ($catid eq $boardcat) { $selected = qq~selected="selected" ~; }
				else { $selected = ""; }
			}
			$catsel{$i} .= qq~<option value="$catid"$selected>$curcatname</option>~;
		}
		$catsel .= qq~</select>~;
</search for>

<replace>
		foreach $catid (@categoryorder) {
			$boardlist = $cat{$catid};
			(@bdlist) = split(/\,/, $boardlist);
			($curcatname, $catperms) = split(/\|/, $catinfo{"$catid"});
			my $boardcat = ${$uid.$editboards[$i]}{'cat'};
			if ($INFO{"action"} eq "boardscreen"){
				if ($pboard{"$editboards[$i]"} eq "") {
					if ($catid eq $boardcat){$selected = qq~selected="selected" ~;} else {$selected = "";}
				} else {
					@parents = split(/\|/, $pboard{"$editboards[$i]"});
					$bdsparent[$i] = $parents[-1];
				}
			}
			$locsel{$i} .= qq~<option value="cat=$catid"$selected>$curcatname</option>~;
			foreach $board (@bdlist) {
				$level = 1;
				($board_name, $trash, $trash) = split(/\|/, $board{"$board"});
				&CalcIcon;
				$disabled = "";
				if ($INFO{"action"} eq "boardscreen"){
					if ($editboards[$i] eq $board){$disabled = qq~ disabled="disabled" ~;}
				}
				if ($board eq $bdsparent[$i]){$selected = qq~ selected="selected" ~;} else {$selected = "";}
				$locsel{$i} .= qq~<option value="board=$board"$selected$disabled>$icon$board_name</option>~;
				if ($sboard{"$board"} ne "") {
					$selectedboard = $editboards[$i];
					$disable_level = 0;
					$subboards = $sboard{"$board"};
					$level++;
					&CalcSubBoards_ManageBoards1;
				}
			}
		}
		$locsel{$i} .= qq~</select>~;
</replace>

<search for>
  </tr><tr>
    <td class="windowbg" width="25%" align="left"><b>$admin_txt{'44'}:</b></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><select name="cat$i">$catsel{$i}</td>
</search for>

<replace>
  </tr><tr>
    <td class="windowbg" width="25%" align="left"><b>$subboard_txt{'2'}:</b></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><select name="loc$i">$locsel{$i} ($subboard_txt{'3'})</td>
</replace>

<search for>
		if ($FORM{'screenornot'} ne "boardscreen") {
			# adding a board
			# make sure no board already exists with that id
			&admin_fatal_error("$admin_txt{'674'} '$id' $admin_txt{'675'}") if (exists $board{"$id"});

			my (@bdlist) = split(/\,/, $cat{"$FORM{\"cat$i\"}"});
			push(@bdlist, "$id");
			my ($bdlist) = join(',', @bdlist);
			$cat{ $FORM{"cat$i"} } = $bdlist;
			fopen(BOARDINFO, ">$boardsdir/$id.txt");
			print BOARDINFO '';
			fclose(BOARDINFO);
		}
		if ($FORM{'screenornot'} eq "boardscreen") {
			# editing a board
			my $category = ${$uid.$id}{'cat'};

			# move category of board
			if ($category ne $FORM{"cat$i"}) {
				${$uid.$id}{'cat'} = qq~$FORM{"cat$i"}~;
				my (@bdlist) = split(/\,/, $cat{$category});

				# Remove Board from old Category
				my $k = 0;
				foreach $bd (@bdlist) {
					if ($id eq $bd) { splice(@bdlist, $k, 1); }
					$k++;
				}
				my $boardlist = join(',', @bdlist);
				$cat{"$category"} = $boardlist;

				# Add Category to new Category
				my $ncat   = $FORM{"cat$i"};
				my $newcat = $cat{$ncat};
				if ($newcat ne "") { $newcat .= ",$id"; }
				else { $newcat .= "$id"; }
				$cat{$ncat} = $newcat;
			}
		}
</search for>

<replace>
		### Determine if this a sub-board or not. ###
		($location, $loc_id) = split(/=/, $FORM{"loc$i"});
		if ($FORM{'screenornot'} ne "boardscreen"){
			### adding a board ###
			# make sure no board already exists with that id
			&admin_fatal_error("$admin_txt{'674'} '$id' $admin_txt{'675'}") if (exists $board{"$id"});

			if ($location eq "cat") {
				my (@bdlist) = split(/\,/, $cat{"$loc_id"});
				push (@bdlist, "$id");
				my ($bdlist) = join (',', @bdlist);
				$cat{"$loc_id"} = $bdlist;
				$cat_id = $loc_id;
			} else {
				# First, add board to parent's sub-board list.
				if ($sboard{"$loc_id"} eq "") { $sboard{"$loc_id"} .= "$id"; }
				else { $sboard{"$loc_id"} .= ",$id"; }

				# Next, add parent to board's parent board list.
				if ($pboard{"$loc_id"} eq "") { $pboard{"$id"} = "$loc_id"; }
				else { $pboard{"$id"} = qq~$pboard{"$loc_id"}|$loc_id~; }
				$cat_id = ${$uid.$loc_id}{'cat'};

				# Add it to all parents' %sblist
				@parents = split(/\|/, $pboard{"$id"});
				foreach $parent (@parents) {
					if ($sblist{"$parent"} eq "") { $sblist{"$parent"} = "$id"; }
					else { $sblist{"$parent"} .= ",$id"; }
				}
			}
			fopen(BOARDINFO, ">$boardsdir/$id.txt");
			print BOARDINFO '';
			fclose(BOARDINFO);

			if (!$pboard{"$id"}) { $pboard{"$id"} = ""; }
			if (!$sboard{"$id"}) { $sboard{"$id"} = ""; }
		}
		if ($FORM{'screenornot'} eq "boardscreen"){
			### editing a board ####
			#chomp $cat[0];
			$oldcategory = ${$uid.$id}{'cat'};
			$oldparents = $pboard{"$id"};

			# Check to see if it will be a sub-board or not.
			if ($location eq "cat") {
				# It will not be a sub-board.
				if ($pboard{"$id"} eq "") {
					# It is not a sub-board, and will not become one.
					my $category = ${$uid.$id}{'cat'};
					### move category of board ###
					if ($category ne $loc_id){
						${$uid.$id}{'cat'} = qq~$loc_id~;
						my (@bdlist) = split(/\,/, $cat{$category});
						#Remove Board from old Category
						my $k = 0;
						foreach $bd (@bdlist){
							if ($id eq $bd){splice (@bdlist,$k,1); }
							$k++;
						}
						my $boardlist = join(',',@bdlist);
						$cat{"$category"} = $boardlist;

						#Add Category to new Category
						my $ncat = $loc_id;
						my $newcat = $cat{$ncat};
						if ($newcat ne ""){$newcat .= ",$id";}
						else {$newcat .= "$id";}
						$cat{$ncat} = $newcat;
					}
				} else {
					# It is a sub-board, and will not be any more.
					${$uid.$id}{'cat'} = qq~$loc_id~;
	
					# Remove it from its parent's sub-board list.
					@parents = split(/\|/, $pboard{"$id"});
					$parent = $parents[-1];
					my (@sblist) = split(/\,/, $sboard{$parent});
					my $k = 0;
					foreach $sb (@sblist){
						if ($id eq $sb){splice (@sblist,$k,1); }
						$k++;
					}
					my $sboardlist = join(/\,/,@sblist);
					$sboard{"$parent"} = $sboardlist;

					# It is not a sub-boards so it won't have any parent boards.
					$pboard{"$id"} = "";
					
					# Add it to a category
					my $ncat = $loc_id;
					my $newcat = $cat{$ncat};
					if ($newcat ne ""){$newcat .= ",$id";}
					else {$newcat .= "$id";}
					$cat{$ncat} = $newcat;
				}
				$cat_id = $loc_id;
			} else {
				# It will be a sub-board.
				# First, check to make sure it's new parent board will not be one of its sub-board
				$parent_check = $loc_id;
				if ($pboard{"$parent_check"} ne "") {
					@parents = split(/\|/, $pboard{"$parent_check"});
					foreach $parentc (@parents) {
						if ($parentc eq $id) {
							&admin_fatal_error("$subboard_txt{'4'}");
						}
					}
				}
				my $former_category = ${$uid.$id}{'cat'};
				${$uid.$id}{'cat'} = qq~${$uid.$parent_check}{'cat'}~; # Category declared for the navigation links.

				if ($pboard{"$id"} eq "") {
					# It is not a sub-board. Remove it from the Category list.
					my (@bdlist) = split(/\,/, $cat{"$former_category"});
					#Remove Board from old Category
					my $k = 0;
					foreach $bd (@bdlist){
						if ($id eq $bd){splice (@bdlist,$k,1); }
						$k++;
					}
					my $boardlist = join(',',@bdlist);
					$cat{"$former_category"} = $boardlist;
				} else {
					# It is a sub-board. Remove it from it's parent's sub-board list.
					@parents = split(/\|/, $pboard{"$id"});
					$parent = $parents[-1];
					my (@sblist) = split(/\,/, $sboard{$parent});
					my $k = 0;
					foreach $sb (@sblist){
						if ($id eq $sb){splice (@sblist,$k,1); }
						$k++;
					}
					my $sboardlist = "";
					foreach $sb (@sblist) {
						if ($sboardlist eq "") { $sboardlist .= "$sb"; }
						else { $sboardlist .= ",$sb"; }
					}
					$sboard{"$parent"} = $sboardlist;
				}
				# Now, let's make it a sub-board
				if ($pboard{"$loc_id"} eq "") { $pboard{"$id"} = "$loc_id"; }
				else { $pboard{"$id"} = qq~$pboard{"$loc_id"}|$loc_id~; }
				if ($sboard{"$loc_id"} eq "") { $sboard{"$loc_id"} = "$id"; }
				else { $sboard{"$loc_id"} .= ",$id"; }
				$cat_id = ${$uid.$loc_id}{'cat'};
			}
			if (!$pboard{"$id"}) { $pboard{"$id"} = ""; }
			if (!$sboard{"$id"}) { $sboard{"$id"} = ""; }

			# Now, let's change the board's sub-boards, if any
			if ($sboard{"$id"} ne "") {
				(@sboardslist) = split(/\,/, $sblist{"$id"});
				if ($cat_id ne $oldcategory) {
					foreach $sb (@sboardslist) {
						push(@boardcontrol, "$cat_id|$sb|${$uid.$sb}{'pic'}|${$uid.$sb}{'description'}|${$uid.$sb}{'mods'}|${$uid.$sb}{'modgroups'}|${$uid.$sb}{'topicperms'}|${$uid.$sb}{'replyperms'}|${$uid.$sb}{'pollperms'}|${$uid.$sb}{'zero'}|${$uid.$sb}{'membergroups'}|${$uid.$sb}{'ann'}|${$uid.$sb}{'rbin'}|${$uid.$sb}{'attperms'}|${$uid.$sb}{'minageperms'}|${$uid.$sb}{'maxageperms'}|${$uid.$sb}{'genderperms'}\n");
						push(@changes,      $sb);
					}
				}
				if ($pboard{"$id"} eq "") { $boardparents = qq~$id~; }
				else { $boardparents = qq~$pboard{"$id"}|$id~; }
				foreach $sb (@sboardslist) {
					$parentlist = $pboard{"$sb"};
					$parentlist =~ s~(.+?)$id(.+?)~$boardparents$2~isg;
				}
			}

			$newcategory = ${$uid.$id}{'cat'};
			if ($newcategory ne $oldcategory || !$catbdlist{"$oldcategory"} || !$catbdlist{"$newcategory"}) {
				&RebuildBoardList_cat;
			}

			$newparents = $pboard{"$id"};
			if ($newparents ne $oldparents || !$sblist{"$id"}) {
				&RebuildBoardList_sub;
			}
		}
</replace>

<search for>
		if ($FORM{"maxage$i"} && $FORM{"maxage$i"} < $FORM{"minage$i"}) { $FORM{"maxage$i"} = $FORM{"minage$i"}; }
</search for>

<add after>
		if ($location ne 'cat') {
			if (${$uid.$loc_id}{'minageperms'} > $FORM{"minage$i"}) { $FORM{"minage$i"} = ${$uid.$loc_id}{'minageperms'}; }
			if (${$uid.$loc_id}{'maxageperms'} < $FORM{"maxage$i"}) { $FORM{"maxage$i"} = ${$uid.$loc_id}{'maxageperms'}; }
			if (${$uid.$loc_id}{'genderperms'} eq 'F' || ${$uid.$loc_id}{'genderperms'} eq 'M') { $FORM{"gender$i"} = ${$uid.$loc_id}{'genderperms'}; }
			elsif (${$uid.$loc_id}{'genderperms'} eq 'B' && $FORM{"gender$i"} eq '') { $FORM{"gender$i"} = 'B'; }
		}
</add after>

<search for>
		push(@boardcontrol, "$FORM{\"cat$i\"}|$id|$FORM{\"pic$i\"}|$bdescription|$FORM{\"moderators$i\"}|$FORM{\"moderatorgroups$i\"}|$FORM{\"topicperms$i\"}|$FORM{\"replyperms$i\"}|$FORM{\"pollperms$i\"}|$FORM{\"zero$i\"}|$FORM{\"membergroups$i\"}|$FORM{\"ann$i\"}|$FORM{\"rbin$i\"}|$FORM{\"att$i\"}|$FORM{\"minage$i\"}|$FORM{\"maxage$i\"}|$FORM{\"gender$i\"}\n");
</search for>

<replace>
		push(@boardcontrol, "$cat_id|$id|$FORM{\"pic$i\"}|$bdescription|$FORM{\"moderators$i\"}|$FORM{\"moderatorgroups$i\"}|$FORM{\"topicperms$i\"}|$FORM{\"replyperms$i\"}|$FORM{\"pollperms$i\"}|$FORM{\"zero$i\"}|$FORM{\"membergroups$i\"}|$FORM{\"ann$i\"}|$FORM{\"rbin$i\"}|$FORM{\"att$i\"}|$FORM{\"minage$i\"}|$FORM{\"maxage$i\"}|$FORM{\"gender$i\"}\n");
</replace>

<search for>
		push(@changes,      $id);
</search for>

<add after>
		if ($FORM{'screenornot'} eq "boardscreen") {
			$subboards = $sboard{"$id"};
			$level++;
			&EditSubBoards_ManageBoards1;
		}
</add after>

<search for>
	if     ($#categoryorder > 0) {
		foreach $category (@categoryorder) {
			chomp $category;
			($categoryname, undef) = split(/\|/, $catinfo{$category});
			&ToChars($categoryname);
			if ($category eq $INFO{"item"}) {
				$categorylistsel = qq~<option value="$category" selected="selected">$categoryname</option>~;
			} else {
				$categorylist .= qq~<option value="$category">$categoryname</option>~;
			}
		}
	}
	(@bdlist) = split(/\,/, $cat{ $INFO{"item"} });
	$bdcnt = @bdlist;
	$bdnum = $bdcnt;
	if ($bdcnt < 4) { $bdcnt = 4; }
	($curcatname, $catperms) = split(/\|/, $catinfo{ $INFO{"item"} });
</search for>

<replace>
	if ($INFO{"location"} eq "board") {
		(@bdlist) = split(/\,/, $sboard{$INFO{"item"}});
		($locationname, $trash) = split(/\|/, $board{$INFO{"item"}});
		$sectiontitle = "$subboard_txt{'1'}";
		$sectiondesc = "$subboard_txt{'5'}";
		$editwhat = "board";
	} else {
		(@bdlist) = split(/\,/, $cat{$INFO{"item"}});
		($locationname, $catperms) = split(/\|/, $catinfo{$INFO{"item"}});
		$sectiontitle = "$admin_txt{'832'}";
		$sectiondesc = "$admin_txt{'739'}";
		$editwhat = "cat";
	}
	$bdcnt = @bdlist;
	$bdnum = $bdcnt;
	if($bdcnt < 4) { $bdcnt = 4; }
</replace>

<search for>
<form action="$adminurl?action=reorderboards2;item=$INFO{'item'}" method="POST">
</search for>

<replace>
<form action="$adminurl?action=reorderboards2;location=$editwhat;item=$INFO{'item'}" method="POST">
</replace>

<search for>
    <td class="titlebg"><img src="$imagesdir/board.gif" alt="" style="vertical-align: middle;" /> <b>$admin_txt{'832'} ($curcatname)</b></td>
</search for>

<replace>
    <td class="titlebg"><img src="$imagesdir/board.gif" alt="" style="vertical-align: middle;" /> <b>$sectiontitle ($locationname)</b></td>
</replace>

<search for>
	if ($bdnum) {
		$yymain .= qq~
    <div style="float: left; width: 280px; text-align: left; margin-bottom: 4px;" class="small">$admin_txt{'739'}</div>
    <div style="float: left; width: 230px; text-align: center; margin-bottom: 4px;">$boardslist</div>
    <div style="float: left; width: 280px; text-align: left; margin-bottom: 4px;" class="small">$admin_txt{'739d'}</div>
    <div style="float: left; width: 230px; text-align: center; margin-bottom: 4px;">
	<input type="submit" value="$admin_txt{'739a'}" name="moveup" style="font-size: 11px; width: 95px;" /><input type="submit" value="$admin_txt{'739b'}" name="movedown" style="font-size: 11px; width: 95px;" />
    </div>
~;
		if ($#categoryorder > 0) {
			$yymain .= qq~
    <div class="small" style="float: left; width: 280px; text-align: left; margin-bottom: 4px;">$admin_txt{'739c'}</div>
    <div style="float: left; width: 230px; text-align: center; margin-bottom: 4px;">
	<select name="selectcategory" style="width: 190px;" onchange="submit();">
	$categorylistsel
	$categorylist
	</select>
    </div>
~;
		}
</search for>

<replace>
	if ($bdnum) {
		$yymain .= qq~
    <div style="float: left; width: 280px; text-align: left; margin-bottom: 4px;" class="small">$sectiondesc</div>
    <div style="float: left; width: 230px; text-align: center; margin-bottom: 4px;">$boardslist</div>
    <div style="float: left; width: 280px; text-align: left; margin-bottom: 4px;" class="small">$admin_txt{'739d'}</div>
    <div style="float: left; width: 230px; text-align: center; margin-bottom: 4px;">
	<input type="submit" value="$admin_txt{'739a'}" name="moveup" style="font-size: 11px; width: 95px;" /><input type="submit" value="$admin_txt{'739b'}" name="movedown" style="font-size: 11px; width: 95px;" />
    </div>
~;
</replace>

<search for>
	@itemorder = split(/\,/, $cat{ $INFO{"item"} });
	my $moveitem = $FORM{'selectboards'};
	my $category = $INFO{"item"};
	if ($moveitem) {
		if ($FORM{'moveup'} || $FORM{'movedown'}) {
			if ($FORM{'moveup'}) {
				for ($i = 0; $i < @itemorder; $i++) {
					if ($itemorder[$i] eq $moveitem && $i > 0) {
						$j             = $i - 1;
						$itemorder[$i] = $itemorder[$j];
						$itemorder[$j] = $moveitem;
						last;
					}
				}
			} elsif ($FORM{'movedown'}) {
				for ($i = 0; $i < @itemorder; $i++) {
					if ($itemorder[$i] eq $moveitem && $i < $#itemorder) {
						$j             = $i + 1;
						$itemorder[$i] = $itemorder[$j];
						$itemorder[$j] = $moveitem;
						last;
					}
				}
			}
			foreach $item (@itemorder) {
				if ($item) {
					$tmp_master .= qq~$item,~;
				}
			}
			$tmp_master =~ s/,\Z//;
			$cat{$category} = qq~$tmp_master~;
		} else {
			if ($category ne $FORM{"selectcategory"}) {
				${$uid.$moveitem}{'cat'} = qq~$FORM{'selectcategory'}~;
				my (@bdlist) = split(/\,/, $cat{$category});
				my $k = 0;
				foreach $bd (@bdlist) {
					if ($moveitem eq $bd) { splice(@bdlist, $k, 1); }
					$k++;
				}
				my $boardlist = join(',', @bdlist);
				$cat{"$category"} = $boardlist;
				my $ncat   = $FORM{"selectcategory"};
				my $newcat = $cat{$ncat};
				if ($newcat ne "") { $newcat .= ",$moveitem"; }
				else { $newcat .= "$moveitem"; }
				$newcat =~ s/,\Z//;
				$cat{$ncat} = $newcat;
				$category = qq~$FORM{"selectcategory"}~;
			}

		}
		&Write_ForumMaster;
</search for>

<replace>
	if ($INFO{"location"} eq "board") {
		@itemorder = split(/\,/, $sboard{ $INFO{"item"} });
		$cur_type = "board";
		$category = ${$uid.$INFO{"item"}}{'cat'};
	} else {
		@itemorder = split(/\,/, $cat{ $INFO{"item"} } );
		$cur_type = "cat";
		$category = $INFO{"item"};
	}
	my $moveitem = $FORM{'selectboards'};
	my $cur_location = $INFO{"item"};
	if ($moveitem) {
		if ($FORM{'moveup'} || $FORM{'movedown'}) {
			if ($FORM{'moveup'}) {
				for ($i = 0; $i < @itemorder; $i++) {
					if ($itemorder[$i] eq $moveitem && $i > 0) {
						$j             = $i - 1;
						$itemorder[$i] = $itemorder[$j];
						$itemorder[$j] = $moveitem;
						last;
					}
				}
			} elsif ($FORM{'movedown'}) {
				for ($i = 0; $i < @itemorder; $i++) {
					if ($itemorder[$i] eq $moveitem && $i < $#itemorder) {
						$j             = $i + 1;
						$itemorder[$i] = $itemorder[$j];
						$itemorder[$j] = $moveitem;
						last;
					}
				}
			}
			foreach $item (@itemorder) {
				if ($item) {
					$tmp_master .= qq~$item,~;
				}
			}
			$tmp_master =~ s/,\Z//;
			if ($INFO{"location"} eq "board") {
				$sboard{$cur_location} = qq~$tmp_master~;
			} else {
				$cat{$cur_location} = qq~$tmp_master~;
			}
		}
		&Write_ForumMaster;
</replace>

<search for>
	$yySetLocation = qq~$adminurl?action=reorderboards;item=$category;theboard=$moveitem~;
</search for>

<replace>
	$yySetLocation = qq~$adminurl?action=reorderboards;location=$cur_type;item=$cur_location;theboard=$moveitem~;
</replace>

<search for>
1;
</search for>

<add before>
sub CalcSubBoards_ManageBoards1 {
	@boardarray = split(/\,/, $subboards);
	$board_count{"$level"} = @boardarray;
	$board_list{"$level"} = $subboards;
	$boardcount = 0;
	while ($boardcount < $board_count{"$level"}) {
		$mboard = $boardarray[$boardcount];
		($mboard_name, $trash, $trash) = split(/\|/, $board{"$mboard"});
		&CalcIcon;
		if ($INFO{"action"} eq "boardscreen"){
			if ($selectedboard eq $mboard) {
				$disabled = qq~ disabled="disabled" ~;
				$disable_level = $level;
			} else {
				if ($disable_level >= $level) {
					$disabled = qq~~;
				}
			}
			if ($mboard eq $bdsparent[$i]){$selected = qq~ selected="selected" ~;} else {$selected = "";}
		}
		$locsel{$i} .= qq~<option value="board=$mboard"$selected$disabled>$icon$mboard_name</option>~;
		if ($sboard{"$mboard"} ne "") {
			$count_store[$level] = $boardcount;
			$subboards = $sboard{"$mboard"};
			$level++;
			&CalcSubBoards_ManageBoards1;
			$level--;
			@boardarray = split(/\,/, $board_list{"$level"});
			$boardcount = $count_store[$level];
		}
		$boardcount++;
	}
}

sub CalcSubBoards_ManageBoards2 {
	@boardarray = split(/\,/, $subboards);
	$board_count{"$level"} = @boardarray;
	$board_list{"$level"} = $subboards;
	$boardcount = 0;
	while ($boardcount < $board_count{"$level"}) {
		$cur_board_id = $boardarray[$boardcount];
		($board_name, $trash, $trash) = split(/\|/, $board{"$cur_board_id"});

		$boardname =~ s/\&quot\;/&#34;/g;
		&ToChars($boardname);
		$descr = ${$uid.$cur_board_id}{'description'};
		$descr =~ s~\<br />~\n~g;
		my $bicon ="";
		if (${$uid.$cur_board_id}{'ann'} == 1) {$bicon = qq~ <img src="$imagesdir/ann.gif" alt="$admin_txt{'64g'}" border="0" />~;}
		if (${$uid.$cur_board_id}{'rbin'} == 1) {$bicon = qq~ <img src="$imagesdir/admin_rem.gif" alt="$admin_txt{'64i'}" border="0" />~;}
		$convertstr = $descr;
		$convertcut = 60;
		&CountChars;
		my $descr = $convertstr;
		&ToChars($descr);
		if ($cliped){$descr .= "...";}

		if ($sboard{"$cur_board_id"} ne "") {
			$reordersubs = qq~<br />(<a href="$adminurl?action=reorderboards;location=board;item=$cur_board_id">$subboard_txt{'1'}</a>)~;
		} else { $reordersubs = ""; }
		&CalcIcon;
		$yymain .= qq~
  <tr>
    <td class="windowbg" width="25%" align="left">$icon$board_name$reordersubs</td>
    <td class="windowbg" width="65%" align="left">$descr</td>
    <td class="windowbg" width="5%" align="center">$bicon</td>
    <td class="titlebg" width="5%" align="center"><input type="checkbox" name="$cur_board_id" value="1" /></td>
  </tr>
~;
		if ($sboard{"$cur_board_id"} ne "") {
			$count_store[$level] = $boardcount;
			$subboards = $sboard{"$cur_board_id"};
			$level++;
			&CalcSubBoards_ManageBoards2;
			$level--;
			@boardarray = split(/\,/, $board_list{"$level"});
			$boardcount = $count_store[$level];
		}
		$boardcount++;
	}
}

sub CalcSubBoards_ManageBoards3 {
	@boardarray = split(/\,/, $sboards);
	$board_count{"$level"} = @boardarray;
	$board_list{"$level"} = $sboards;
	$boardcount = 0;
	push(@fullbrdlist, @boardarray);
	while ($boardcount < $board_count{"$level"}) {
		$full_board_id = $boardarray[$boardcount];
		if ($sboard{"$full_board_id"} ne "") {
			$count_store[$level] = $boardcount;
			$sboards = $sboard{"$full_board_id"};
			$level++;
			&CalcSubBoards_ManageBoards3;
			$level--;
			@boardarray = split(/\,/, $board_list{"$level"});
			$boardcount = $count_store[$level];
		}
		$boardcount++;
	}
}

sub EditSubBoards_ManageBoards1 {
	@boardarray = split(/\,/, $subboards);
	$board_count{"$level"} = @boardarray;
	$board_list{"$level"} = $subboards;
	$boardcount = 0;
	push(@fullbrdlist, @boardarray);
	while ($boardcount < $board_count{"$level"}) {
		$full_board_id = $boardarray[$boardcount];
		$parents = $pboard{"$full_board_id"};
		$parents =~ s~(.*?)\|$id\|(.*?)~$pboard{"$id"}\|$id\|$2~isg;
		$pboard{"$full_board_id"} = $parents;
		if ($sboard{"$full_board_id"} ne "") {
			$count_store[$level] = $boardcount;
			$subboards = $sboard{"$full_board_id"};
			$level++;
			&EditSubBoards_ManageBoards1;
			$level--;
			@boardarray = split(/\,/, $board_list{"$level"});
			$boardcount = $count_store[$level];
		}
		$boardcount++;
	}
}

sub RebuildBoardList_cat {
	%catbdlist = ();
	foreach $category (@categoryorder) {
		$catbdlist{"$category"} = "";
	}
	foreach $board_1 (keys %board) {
		$category = ${$uid.$board_1}{'cat'};
		$catbdlist{"$category"} .= "$board_1,";
	}
	foreach $category (@categoryorder) {
		chop ($catbdlist{"$category"});
	}
}

sub RebuildBoardList_sub {
	%sblist = ();
	foreach $board_1 (keys %board) {
		$sblist{"$board_1"} = "";
	}
	foreach $board_1 (keys %board) {
		if ($pboard{"$board_1"} ne "") {
			@parents = split(/\|/, $pboard{"$board_1"});
			foreach $parent (@parents) {
				$sblist{"$parent"} .= "$board_1,";
			}
		}
	}
	foreach $board_1 (keys %board) {
		chop ($sblist{"$board_1"});
	}
}
</add before>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
 	$my_mod = "Sub-Board_for_YaBB_2.1|BRO_co03|This mod allows one to create sub-boards for YaBB 2.1.<br /><br /><b>To create a sub-board:</b><br />1) In the Manage Boards section, edit or add a board.<br />2) Under the Location option, choose a parent board for your currently edited board, and Save.<br /><br /><b>To reorder the subboards:</b><br />1) Click the <u>Reorder Sub-boards</u> link in the Manage Boards section.<br />2) Rearrange the boards in the order you choose, and Save.|1.0.8|7/25/06";
	push (@installed_mods, "$my_mod");

</add before>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
LoadLanguage("BoardIndex");
</search for>

<add after>
LoadLanguage("SubBoard");
</add after>

<search for>
	&BoardTotals("load", @loadboards);
	&getlog(@goodboards);
	foreach $curboard (@loadboards) {
		chomp $curboard;
		$lastposttime = ${$uid.$curboard}{'lastposttime'};
		${$uid.$curboard}{'lastposttime'} = ${$uid.$curboard}{'lastposttime'} eq 'N/A' || !${$uid.$curboard}{'lastposttime'} ? $boardindex_txt{'470'} : ${$uid.$curboard}{'lastposttime'};
		if (${$uid.$curboard}{'lastposttime'} != 0) { $lastposttime{$curboard} = &timeformat(${$uid.$curboard}{'lastposttime'}); }
		else { $lastposttime{$curboard} = $boardindex_txt{'470'}; }
		$lastpostrealtime{$curboard} = ${$uid.$curboard}{'lastposttime'} eq 'N/A' || !${$uid.$curboard}{'lastposttime'} ? '' : ${$uid.$curboard}{'lastposttime'};
		$lsreply{$curboard} = ${$uid.$curboard}{'lastreply'} + 1;
		if (${$uid.$curboard}{'lastposter'} =~ m~\AGuest-(.*)~) {
			${$uid.$curboard}{'lastposter'} = $1;
			$lastposterguest{$curboard} = 1;
		}
		${$uid.$curboard}{'lastposter'}   = ${$uid.$curboard}{'lastposter'} eq 'N/A' || !${$uid.$curboard}{'lastposter'} ? $boardindex_txt{'470'} : ${$uid.$curboard}{'lastposter'};
		${$uid.$curboard}{'messagecount'} = ${$uid.$curboard}{'messagecount'}        || 0;
		${$uid.$curboard}{'threadcount'}  = ${$uid.$curboard}{'threadcount'}         || 0;
		$totalm += ${$uid.$curboard}{'messagecount'};
		$totalt += ${$uid.$curboard}{'threadcount'};
</search for>

<replace>
	@loadsubboards = ();
	foreach $topboard (@loadboards) {
		if ($sblist{"$topboard"} eq "") { next; }
		@subboard_lists = split(/\,/, $sblist{"$topboard"});
		foreach $tbsb (@subboard_lists) {
			my ($boardname, $boardperms, $boardview) = split(/\|/, $board{"$tbsb"});
			my $access = &AccessCheck($tbsb, '', $boardperms);
			if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }
			@sbpb = split(/\|/, $pboard{"$tbsb"});
			$dontaccess = "false";
			foreach $subsparent (@sbpb) {
				my ($boardname, $boardperms, $boardview) = split(/\|/, $board{"$subsparent"});
				my $access = &AccessCheck($subsparent, '', $boardperms);
				if (!$iamadmin && $access ne "granted" && $boardview != 1) { $dontaccess = "true"; last; }
			}
			if ($dontaccess eq "true") { next; }
			push(@loadsubboards, $tbsb);
		}
	}
	foreach $goodtopboard (@goodboards) {
		($brdcat, $topbrd) = split(/\|/, $goodtopboard);
		if ($sblist{"$topbrd"} eq "") { next; }
		@subboard_lists = split(/\,/, $sblist{"$topbrd"});
		foreach $goodsbrd (@subboard_lists) {
			push(@goodsubboards, "$brdcat|$goodsbrd");
		}
	}
	&BoardTotals("load", @loadboards);
	&BoardTotals("load",@loadsubboards);
	&getlog(@goodboards);
	foreach $curboard (@loadboards) {
		chomp $curboard;
		$lastposttime = ${$uid.$curboard}{'lastposttime'};
		${$uid.$curboard}{'lastposttime'} = ${$uid.$curboard}{'lastposttime'} eq 'N/A' || !${$uid.$curboard}{'lastposttime'} ? $boardindex_txt{'470'} : ${$uid.$curboard}{'lastposttime'};
		if (${$uid.$curboard}{'lastposttime'} != 0) { $lastposttime{$curboard} = &timeformat(${$uid.$curboard}{'lastposttime'}); }
		else { $lastposttime{$curboard} = $boardindex_txt{'470'}; }
		$lastpostrealtime{$curboard} = ${$uid.$curboard}{'lastposttime'} eq 'N/A' || !${$uid.$curboard}{'lastposttime'} ? '' : ${$uid.$curboard}{'lastposttime'};
		$lsreply{$curboard} = ${$uid.$curboard}{'lastreply'} + 1;
		if (${$uid.$curboard}{'lastposter'} =~ m~\AGuest-(.*)~) {
			${$uid.$curboard}{'lastposter'} = $1;
			$lastposterguest{$curboard} = 1;
		}
		${$uid.$curboard}{'lastposter'}   = ${$uid.$curboard}{'lastposter'} eq 'N/A' || !${$uid.$curboard}{'lastposter'} ? $boardindex_txt{'470'} : ${$uid.$curboard}{'lastposter'};
		${$uid.$curboard}{'messagecount'} = ${$uid.$curboard}{'messagecount'}        || 0;
		${$uid.$curboard}{'threadcount'}  = ${$uid.$curboard}{'threadcount'}         || 0;
		$totalmessagecount{"$curboard"} = ${$uid.$curboard}{'messagecount'};
		$totalthreadcount{"$curboard"} = ${$uid.$curboard}{'threadcount'};
		@subboard_lists = split(/\,/, $sblist{"$curboard"});
		foreach $subboard_list (@subboard_lists) {
			my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$subboard_list"});
			my $access = &AccessCheck($subboard_list, '', $subboard_perms);
			if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
			$totalmessagecount{"$curboard"} += ${$uid.$subboard_list}{'messagecount'};
			$totalthreadcount{"$curboard"} += ${$uid.$subboard_list}{'threadcount'};
		}
		$totalm += $totalmessagecount{"$curboard"};
		$totalt += $totalthreadcount{"$curboard"};
</replace>

<search for>
		# determine the true last post on all the boards a user has access to
		if (${$uid.$curboard}{'lastposttime'} > $lastthreadtime && $lastposttime{$curboard} ne $boardindex_txt{'470'}) {
			$lsdatetime     = $lastposttime{$curboard};
			$lsposter       = ${$uid.$curboard}{'lastposter'};
			$lssub          = ${$uid.$curboard}{'lastsubject'};
			$lspostid       = ${$uid.$curboard}{'lastpostid'};
			$lsreply        = ${$uid.$curboard}{'lastreply'};
			$lastthreadtime = ${$uid.$curboard}{'lastposttime'};
			$lspostbd       = $curboard;
		}

	}
</search for>

<replace>
	}
	foreach $catid (@categoryorder) {
		if ($INFO{'catselect'} ne $catid && $INFO{'catselect'}) { next; }
		$boardlist = $catbdlist{$catid};
		(@bdlist) = split(/\,/, $boardlist);
		my ($catname, $catperms, $catallowcol) = split(/\|/, $catinfo{"$catid"});

		# Category Permissions Check
		my $access = &CatAccess($catperms);
		if (!$access) { next; }

		foreach $curboard (@bdlist) {
			# now fill all the neccesary hashes to show all board index stuff
			chomp $curboard;
			if (!exists $board{$curboard}) {
				&gostRemove($catid, $curboard);
				next;
			}

			# hide the actual global announcement board for all normal users but admins and gmods
			if ($annboard eq $curboard && !$iamadmin && !$iamgmod) { next; }

			my ($boardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }

			if (${$uid.$curboard}{'lastposttime'} != 0) { $lastposttime{$curboard} = &timeformat(${$uid.$curboard}{'lastposttime'}); }
			else { $lastposttime{$curboard} = $boardindex_txt{'470'}; }

			# determine the true last post on all the boards a user has access to
			if (${$uid.$curboard}{'lastposttime'} > $lastthreadtime && $lastposttime{$curboard} ne $boardindex_txt{'470'}) {
				$lsdatetime     = $lastposttime{$curboard};
				$lsposter       = ${$uid.$curboard}{'lastposter'};
				$lssub          = ${$uid.$curboard}{'lastsubject'};
				$lspostid       = ${$uid.$curboard}{'lastpostid'};
				$lsreply        = ${$uid.$curboard}{'lastreply'};
				$lastthreadtime = ${$uid.$curboard}{'lastposttime'};
				$lspostbd       = $curboard;
			}
		}
	}
</replace>

<search for>
				if ($showmodgroups eq "" && $showmods eq "") { $showmodgroups = qq~<br />~; }
				if ($showmodgroups ne "" && $showmods ne "") { $showmods .= qq~<br />~; }
</search for>

<replace>
				if ($sboard{"$curboard"} ne "") {
					my @subboard = split(/\,/, $sboard{"$curboard"});
					$commacount = 1;
					$subboardlist = "";
					foreach $sub (@subboard) {
						my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$sub"});
						my $access = &AccessCheck($sub, '', $subboard_perms);
						if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
						if ($commacount++ == 1) {
							$subboardlist .= qq~<a href="$scripturl?board=$sub" class="nav">$subboard_name</a>~;
						} else {
							$subboardlist .= qq~, <a href="$scripturl?board=$sub" class="nav">$subboard_name</a>~;
						}
					}
					if ( $subboardlist ne "" ) {
						$subcount = @subboard;
						if ($subcount == 1) { $subboards = "$subboard_txt{'6'}: $subboardlist"; }
						else {$subboards = "$subboard_txt{'7'}: $subboardlist"; }
					} else { $subboards = ""; }
				} else { $subboards = ""; }

				if ($showmodgroups eq "" && $showmods eq "" && $subboards eq "") { $subboards = qq~<br />~; }
				if ($showmodgroups eq "" && $showmods ne "" && $subboards ne "") { $showmods .= qq~<br />~; }
				if ($showmodgroups ne "" && $showmods ne "" && $subboards eq "") { $showmods .= qq~<br />~; }
				if ($showmodgroups ne "" && $showmods eq "" && $subboards ne "") { $showmodgroups .= qq~<br />~; }
				if ($showmodgroups ne "" && $showmods ne "" && $subboards ne "") { $showmods .= qq~<br />~; $showmodgroups .= qq~<br />~; }
</replace>

<search for>
				foreach my $boardinfo (@goodboards) {
					chomp $boardinfo;
					my ($testcat);
					($testcat, $curboard) = split(/\|/, $boardinfo);
					if ($testcat ne $catid) { next; }

					# as we fill the vars based on all boards we need to skip any cat already shown before
					my $dlp = $yyuserlog{$curboard} ? $yyuserlog{$curboard} : 0;
					if ($max_log_days_old && ${$uid.$curboard}{'lastposttime'} ne $boardindex_txt{'470'} && $dlp < $lastpostrealtime{$curboard} && ($dlp > $max_log_days_old * 86400 || $dlp == 0)) {
						my (undef, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
						if (&AccessCheck($curboard, '', $boardperms) eq "granted") { $newmsg = 1; }
					}
				}
</search for>

<replace>
				foreach my $boardinfo (@goodboards) {
					chomp $boardinfo;
					my ($testcat);
					($testcat, $curboard) = split(/\|/, $boardinfo);
					if ($testcat ne $catid) { next; }

					# as we fill the vars based on all boards we need to skip any cat already shown before
					my $dlp = $yyuserlog{$curboard} ? $yyuserlog{$curboard} : 0;
					if ($max_log_days_old && ${$uid.$curboard}{'lastposttime'} ne $boardindex_txt{'470'} && $dlp < $lastpostrealtime{$curboard} && ($dlp > $max_log_days_old * 86400 || $dlp == 0)) {
						my (undef, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
						if (&AccessCheck($curboard, '', $boardperms) eq "granted") { $newmsg = 1; }
					}
					@subboard_lists = split(/\,/, $sblist{"$curboard"});
					foreach $subboardlist (@subboard_lists) {
						my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$subboardlist"});
						my $access = &AccessCheck($subboard_list, '', $subboard_perms);
						if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
						my $dlp = $yyuserlog{$subboardlist} ? $yyuserlog{$subboardlist} : 0;
						$lastpostrealtime{$subboardlist} = ${$uid.$subboardlist}{'lastposttime'} eq 'N/A' || ! ${$uid.$subboardlist}{'lastposttime'} ? '' : ${$uid.$subboardlist}{'lastposttime'};
						if( $max_log_days_old && ${$uid.$subboardlist}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$subboardlist} && ($dlp>$max_log_days_old*86400 || $dlp eq 0)) {
							$newmsg = 1; last;
						}
					}
				}
</replace>

<search for>
				my $dlp = $yyuserlog{$curboard} ? $yyuserlog{$curboard} : 0;
				if ($max_log_days_old && ${$uid.$curboard}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$curboard} && ($dlp > $max_log_days_old * 86400 || $dlp == 0)) {
					my (undef, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
					if (&AccessCheck($curboard, '', $boardperms) eq "granted") {
						$new = qq~<img src="$imagesdir/on.gif" alt="$boardindex_txt{'333'}" border="0" />~;
					} else {
						$new = qq~<img src="$imagesdir/off.gif" alt="$boardindex_txt{'334'}" border="0" />~;
					}
				} else {
					$new = qq~<img src="$imagesdir/off.gif" alt="$boardindex_txt{'334'}" border="0" />~;
				}
				if (${$uid.$curboard}{'ann'} == 1)  { $new = qq~<img src="$imagesdir/ann.gif" alt="" border="0" />~; }
				if (${$uid.$curboard}{'rbin'} == 1) { $new = qq~<img src="$imagesdir/recycle.gif" alt="" border="0" />~; }
</search for>

<replace>
				my $dlp = $yyuserlog{$curboard} ? $yyuserlog{$curboard} : 0;
				if ($max_log_days_old && ${$uid.$curboard}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$curboard} && ($dlp > $max_log_days_old * 86400 || $dlp == 0)) {
					my (undef, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
					if (&AccessCheck($curboard, '', $boardperms) eq "granted") {
						$new = qq~<img src="$imagesdir/on.gif" alt="$boardindex_txt{'333'}" border="0" />~;
					} else {
						$new = qq~<img src="$imagesdir/off.gif" alt="$boardindex_txt{'334'}" border="0" />~;
					}
				} else {
					$new = qq~<img src="$imagesdir/off.gif" alt="$boardindex_txt{'334'}" border="0" />~;
				}
				@subboard_lists = split(/\,/, $sblist{"$curboard"});
				foreach $subboardlist (@subboard_lists) {
					my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$subboardlist"});
					my $access = &AccessCheck($subboard_list, '', $subboard_perms);
					if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
					my $dlp = $yyuserlog{$subboardlist} ? $yyuserlog{$subboardlist} : 0;
					$lastpostrealtime{$subboardlist} = ${$uid.$subboardlist}{'lastposttime'} eq 'N/A' || ! ${$uid.$subboardlist}{'lastposttime'} ? '' : ${$uid.$subboardlist}{'lastposttime'};
					if( $max_log_days_old && ${$uid.$subboardlist}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$subboardlist} && ($dlp>$max_log_days_old*86400 || $dlp eq 0)) {
						$new = qq~<img src="$imagesdir/on.gif" alt="$boardindex_txt{'333'}" border="0" />~; last;
					}
				}
				if (${$uid.$curboard}{'ann'} == 1)  { $new = qq~<img src="$imagesdir/ann.gif" alt="" border="0" />~; }
				if (${$uid.$curboard}{'rbin'} == 1) { $new = qq~<img src="$imagesdir/recycle.gif" alt="" border="0" />~; }
</replace>

<search for>
				my $lasttopiclink = qq~<a href="$scripturl?num=${$uid.$curboard}{'lastpostid'}/${$uid.$curboard}{'lastreply'}#${$uid.$curboard}{'lastreply'}" title="$fulltopictext">$lasttopictxt</a>~;
				if (${$uid.$curboard}{'threadcount'} < 0)  { ${$uid.$curboard}{'threadcount'}  = 0; }
				if (${$uid.$curboard}{'messagecount'} < 0) { ${$uid.$curboard}{'messagecount'} = 0; }
				$templateblock =~ s/<yabb boardanchor>/$curboard/g;
				$templateblock =~ s/<yabb boardurl>/$scripturl\?board\=$curboard/g;
				$templateblock =~ s/<yabb new>/$new/g;
				$templateblock =~ s/<yabb boardpic>/$bdpic/g;
				$templateblock =~ s/<yabb boardname>/$boardname/g;
				$templateblock =~ s/<yabb boarddesc>/$bddescr/g;
				$templateblock =~ s/<yabb moderators>/$showmods$showmodgroups/g;
				$templateblock =~ s/<yabb threadcount>/${$uid.$curboard}{'threadcount'}/g;
				$templateblock =~ s/<yabb messagecount>/${$uid.$curboard}{'messagecount'}/g;
				$templateblock =~ s/<yabb lastpostlink>/$lastpostlink/g;
				$templateblock =~ s/<yabb lastposter>/$lastposter/g;
				$templateblock =~ s/<yabb lasttopiclink>/$lasttopiclink/g;
</search for>

<replace>
				# Determine last post in subboards
				if ($sboard{"$curboard"} ne "") {
					$sblastpost = 0;
					@allsboards = split(/\,/, $sblist{"$curboard"});
					foreach $sb (@allsboards) {
						my ($sboardname, $sboardperms, $sboardview) = split(/\|/, $board{"$sb"});
						my $access = &AccessCheck($sb, '', $sboardperms);
						if (!$iamadmin && $access ne "granted" && $sboardview != 1) { next; }

						(@sbparents) = split(/\|/, $pboards{"$sb"});
						my ($spboardname, $spboardperms, $spboardview) = split(/\|/, $board{"$sbparents[-1]"});
						my $parentaccess = &AccessCheck("$sbparents[-1]", '', $spboardperms);
						if (!$iamadmin && $access ne "granted" && $parentaccess ne "granted") { next; }

						if (${$uid.$sb}{'lastposttime'} eq "") { next; }
						if (!$iammodhere && !$iamadmin && !$iamgmod) {
							fopen(MNUM, "$boardsdir/$sb.txt");
							@threadlist = <MNUM>;
							fclose(MNUM);
							my (@messarr) = split(/\|/, $threadlist[0]);
							$messagestate = pop(@messarr);
							if ($messagestate =~ /h/i) {
								${$uid.$sb}{'lastpostid'}   = "";
								${$uid.$sb}{'lastsubject'}  = "";
								${$uid.$sb}{'lastreply'}    = "";
								${$uid.$sb}{'lastposter'}   = qq~$boardindex_txt{'470'}~;
								${$uid.$sb}{'lastposttime'} = 0;
								$lastposttime{$sb} = qq~$boardindex_txt{'470'}~;
								for ($i = 1; $i < @threadlist; $i++) {
									($messageid, $messagesubject, undef, undef, undef, undef, undef, undef, $messagestate) = split(/\|/, $threadlist[$i]);
									if ($messagestate !~ /h/i) {
										fopen(MDATA, "$datadir/$messageid.ctb");
										@threaddata = <MDATA>;
										fclose(MDATA);
										chomp @threaddata;
										${$uid.$sb}{'lastpostid'}   = $messageid;
										${$uid.$sb}{'lastsubject'}  = $messagesubject;
										${$uid.$sb}{'lastreply'}    = $threaddata[1];
										${$uid.$sb}{'lastposter'}   = $threaddata[3];
										${$uid.$sb}{'lastposttime'} = $threaddata[4];
										$lastposttime{$sb} = &timeformat($threaddata[4]);
										last;
									}
								}
							}
						}
						if (${$uid.$sb}{'lastposttime'} > $sblastpost) {
							$sbdatetime     = $lastposttime{$sb};
							$sblastposter   = ${$uid.$sb}{'lastposter'};
							$sblastpostsub  = ${$uid.$sb}{'lastsubject'};
							$sblastpostid   = ${$uid.$sb}{'lastpostid'};
							$sblastreply    = ${$uid.$sb}{'lastreply'};
							$sblastpost     = ${$uid.$sb}{'lastposttime'};
							$sblastpostbd   = $sb;
						}
					}
					$sblastposter = ${$uid.$sblastpostbd}{'lastposter'};
					$sblastposter =~ s~\AGuest-(.*)~$1~i;

					if (${$uid.$sblastpostbd}{'lastposttime'} != 0) { $lastposttime{$sblastpostbd} = &timeformat(${$uid.$sblastpostbd}{'lastposttime'}); }
					else { $lastposttime{$sblastpostbd} = $boardindex_txt{'470'}; }

					unless ($lastposterguest{$sblastpostbd} || ${$uid.$sblastpostbd}{'lastposter'} eq $boardindex_txt{'470'}) {
						&LoadUser($sblastposter);
						$registrationdate = ${$uid.$sblastposter}{'regtime'};

						$sbmessagedate = ${$uid.$sblastpostbd}{'lastposttime'};

						if ((${$uid.$sblastposter}{'regdate'} && $sbmessagedate > $registrationdate) || ${$uid.$sblastposter}{'status'} eq "Administrator" || ${$uid.$sblastposter}{'status'} eq "Global Moderator") {
							$sblastposter = qq~<a href="$scripturl?action=viewprofile;username=$sblastposter">${$uid.$sblastposter}{'realname'}</a>~;
						} else {
							$sblastposter .= qq~ - $boardindex_txt{'470a'}~;
						}
					}
					${$uid.$sblastpostbd}{'lastposter'}   ||= $boardindex_txt{'470'};
					${$uid.$sblastpostbd}{'lastposttime'} ||= $boardindex_txt{'470'};
					if (!$topiccut) { $topiccut = 15; }
					my $sblasttopictxt = ${$uid.$sblastpostbd}{'lastsubject'};
					$sblasttopictxt =~ s/\A\[m\]/$maintxt{'758'}/;

					# Censor the subject
					&LoadCensorList;
					$sblasttopictxt = &Censor($sblasttopictxt);
					$sbfulltopictext = qq~$sblasttopictxt~;

					if (${$uid.$sblastpostbd}{'lastreply'} ne "") {
						$sblastpostlink = qq~<a href="$scripturl?num=${$uid.$sblastpostbd}{'lastpostid'}/${$uid.$sblastpostbd}{'lastreply'}#${$uid.$sblastpostbd}{'lastreply'}">$img{'lastpost'}</a> $lastposttime{$sblastpostbd}~;
					} else {
						$sblastpostlink = qq~$img{'lastpost'} $boardindex_txt{'470'}~;
					}

					$convertstr = $sblasttopictxt;
					$convertcut = $topiccut;
					&FromHTML($convertstr);
					&CountChars;
					my $sblasttopictxt = $convertstr;
					&ToChars($sblasttopictxt);
					&ToChars($sbfulltopictext);

					if ($cliped) { $sblasttopictxt .= "..."; }

					$sblasttopictxt =~ s/  / \&nbsp;/g;
					$sblasttopictxt =~ s/</&lt;/g;
					$sblasttopictxt =~ s/>/&gt;/g;
					$sblasttopictxt =~ s/\|/\&#124;/g;

					$sbfulltopictext =~ s/</&lt;/g;
					$sbfulltopictext =~ s/>/&gt;/g;
					$sbfulltopictext =~ s/\|/\&#124;/g;

					$sblasttopicsubject = $sblasttopictxt;
				}

				if ($sboard{"$curboard"} ne "" && $sblastpost > ${$uid.$curboard}{'lastposttime'}) {
					$lasttopiclink = qq~<a href="$scripturl?num=${$uid.$sblastpostbd}{'lastpostid'}/${$uid.$sblastpostbd}{'lastreply'}#${$uid.$sblastpostbd}{'lastreply'}" title="$sbfulltopictext">$sblasttopicsubject</a>~;
					$lastposter = $sblastposter;
					$lastpostlink = $sblastpostlink;
				} else {
					$lasttopiclink = qq~<a href="$scripturl?num=${$uid.$curboard}{'lastpostid'}/${$uid.$curboard}{'lastreply'}#${$uid.$curboard}{'lastreply'}" title="$fulltopictext">$lasttopictxt</a>~;
				}

				if (${$uid.$curboard}{'threadcount'} < 0)  { ${$uid.$curboard}{'threadcount'}  = 0; }
				if (${$uid.$curboard}{'messagecount'} < 0) { ${$uid.$curboard}{'messagecount'} = 0; }
				$templateblock =~ s/<yabb boardanchor>/$curboard/g;
				$templateblock =~ s/<yabb boardurl>/$scripturl\?board\=$curboard/g;
				$templateblock =~ s/<yabb new>/$new/g;
				$templateblock =~ s/<yabb boardpic>/$bdpic/g;
				$templateblock =~ s/<yabb boardname>/$boardname/g;
				$templateblock =~ s/<yabb boarddesc>/$bddescr/g;
				$templateblock =~ s/<yabb moderators>/$showmods$showmodgroups/g;
				$templateblock =~ s/<yabb subboards>/$subboards/g;
				$templateblock =~ s/<yabb threadcount>/$totalthreadcount{"$curboard"}/g;
				$templateblock =~ s/<yabb messagecount>/$totalmessagecount{"$curboard"}/g;
				$templateblock =~ s/<yabb lastpostlink>/$lastpostlink/g;
				$templateblock =~ s/<yabb lastposter>/$lastposter/g;
				$templateblock =~ s/<yabb lasttopiclink>/$lasttopiclink/g;

</replace>

<search for>
sub MarkAllRead {
	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }

  CAT: foreach my $catid (@categoryorder) {
		if ($INFO{'cat'} ne '') {
			if ($INFO{'cat'} eq $catid) {
				$boardlist = $cat{$catid};
				(@bdlist) = split(/\,/, $boardlist);
				($catname, $catperms) = split(/\|/, $catinfo{"$catid"});

				# Category Permissions Check
				$cataccess = &CatAccess($catperms);
				if (!$cataccess) { next; }
			  BOARD: foreach $curboard (@bdlist) {
					chomp $curboard;
					&modlog("$curboard--mark");
					&modlog($curboard);

					next BOARD;
				}
				last CAT;
			} else {
				next CAT;
			}
		} else {
			$boardlist = $cat{$catid};
			(@bdlist) = split(/\,/, $boardlist);
			($catname, $catperms) = split(/\|/, $catinfo{"$catid"});

			# Category Permissions Check
			$cataccess = &CatAccess($catperms);
			if (!$cataccess) { next; }
		  BOARD: foreach $curboard (@bdlist) {
				chomp $curboard;
				&modlog("$curboard--mark");
				&modlog($curboard);
				next BOARD;
			}
		}
	}
	&dumplog;
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
}
</search for>

<replace>
sub MarkAllRead {
	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }

  CAT: foreach my $catid (@categoryorder) {
		if ($INFO{'cat'} ne '') {
			if ($INFO{'cat'} eq $catid) {
				$boardlist = $catbdlist{$catid};
				(@bdlist) = split(/\,/, $boardlist);
				($catname, $catperms) = split(/\|/, $catinfo{"$catid"});

				# Category Permissions Check
				$cataccess = &CatAccess($catperms);
				if (!$cataccess) { next; }
			  BOARD: foreach $curboard (@bdlist) {
					chomp $curboard;
					&modlog("$curboard--mark");
					&modlog($curboard);

					next BOARD;
				}
				last CAT;
			} else {
				next CAT;
			}
		} else {
			$boardlist = $catbdlist{$catid};
			(@bdlist) = split(/\,/, $boardlist);
			($catname, $catperms) = split(/\|/, $catinfo{"$catid"});

			# Category Permissions Check
			$cataccess = &CatAccess($catperms);
			if (!$cataccess) { next; }
		  BOARD: foreach $curboard (@bdlist) {
				chomp $curboard;
				&modlog("$curboard--mark");
				&modlog($curboard);
				next BOARD;
			}
		}
	}
	&dumplog;
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
}
</replace>

<edit file>
Sources/Display.pl
</edit file>

<search for>
LoadLanguage("Display");
LoadLanguage("FA");
</search for>

<add after>
LoadLanguage("SubBoard");
</add after>

<search for>
	# Template it
</search for>

<add before>
	if ($pboard{"$currentboard"} ne "") {
		my @parents = ();
		@parents = split(/\|/, $pboard{"$currentboard"});
		$parentboards = "";
		foreach $parent (@parents) {
			($parent_name, $trash, $trash) = split(/\|/, $board{"$parent"});
			$parentboards .= qq~<a href="$scripturl?board=$parent" class="nav">$parent_name</a>$parentseparator~;
		}
	} else { $parentboards = ""; }

</add before>

<search for>
	$display_template =~ s/<yabb board>/$template_board/g;
</search for>

<add before>
	$display_template =~ s/<yabb parentboards>/$parentboards/g;
</add before>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
LoadLanguage("MessageIndex");
</search for>

<add after>
LoadLanguage("SubBoard");
</add after>

<search for>
	if (&AccessCheck($currentboard, '', $boardperms) ne "granted") { &fatal_error("$maintxt{'1'}"); }
	if ($annboard eq $currentboard && !$iamadmin && !$iamgmod) { &fatal_error("$maintxt{'1'}"); }

</search for>

<add after>
	if ($pboard{"$currentboard"} ne "") {
		my @parents = ();
		@parents = split(/\|/, $pboard{"$currentboard"});
		foreach $parent (@parents) {
			($board_name, $board_perms, $board_view) = split(/\|/, $board{"$parent"});
			my $access = &AccessCheck($parent, '', $board_perms);
			if (!$iamadmin && $access ne "granted" && $board_view != 1) { &fatal_error("$maintxt{'1'}"); }
		}
	}
</add after>

<search for>
LoadLanguage("MessageIndex");
</search for>

<add before>
LoadLanguage("BoardIndex");
</add before>

<search for>
	#template it
</search for>

<add before>
	if ($sboard{"$currentboard"} ne "") {
		$subboardlist = $sboard{"$currentboard"};
		@sblist = split(/\,/, $subboardlist);
		foreach $curboard (@sblist) {
			## now fill all the neccesary hashes to show all board index stuff ##
			chomp $curboard;
			$cat_boardcnt{$catid}++;
			my ($sboardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted" && $boardview != 1) {next;}
			push (@goodboards, "$catid|$curboard");
			push (@loadboards, $curboard);
		}
		if ($loadboards[0] ne "") {
			&BoardTotals("load",@loadboards);
			foreach $topboard (@loadboards) {
				@subboard_lists = split(/\,/, $sblist{"$topboard"});
				foreach $tbsb (@subboard_lists) {
					my ($boardname, $boardperms, $boardview) = split(/\|/, $board{"$tbsb"});
					my $access = &AccessCheck($tbsb, '', $boardperms);
					if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }
					push(@loadsubboards, $tbsb);
				}
			}
			if ($loadsubboards[0] ne "") { &BoardTotals("load",@loadsubboards); }
			&getlog(@goodboards);
			foreach $curboard (@loadboards) {
				chomp $curboard;
				$lastposttime = ${$uid.$curboard}{'lastposttime'};
				${$uid.$curboard}{'lastposttime'} = ${$uid.$curboard}{'lastposttime'} eq 'N/A' || ! ${$uid.$curboard}{'lastposttime'} ? $boardindex_txt{'470'} : ${$uid.$curboard}{'lastposttime'};
				if(${$uid.$curboard}{'lastposttime'} != 0){$lastposttime{$curboard} = &timeformat(${$uid.$curboard}{'lastposttime'});} else {$lastposttime{$curboard} = $boardindex_txt{'470'};}
				$lastpostrealtime{$curboard} = ${$uid.$curboard}{'lastposttime'} eq 'N/A' || ! ${$uid.$curboard}{'lastposttime'} ? '' : ${$uid.$curboard}{'lastposttime'};
				$lsreply{$curboard} = ${$uid.$curboard}{'lastreply'}+ 1;
				if( ${$uid.$curboard}{'lastposter'} =~ m~\AGuest-(.*)~ ) {
					${$uid.$curboard}{'lastposter'} = $1;
					$lastposterguest{$curboard} = 1;
				}
				${$uid.$curboard}{'lastposter'} = ${$uid.$curboard}{'lastposter'} eq 'N/A' || ! ${$uid.$curboard}{'lastposter'} ? $boardindex_txt{'470'} : ${$uid.$curboard}{'lastposter'};
				${$uid.$curboard}{'messagecount'} = ${$uid.$curboard}{'messagecount'} || 0;
				${$uid.$curboard}{'threadcount'} = ${$uid.$curboard}{'threadcount'} || 0;
				$totalmessagecount{"$curboard"} = ${$uid.$curboard}{'messagecount'};
				$totalthreadcount{"$curboard"} = ${$uid.$curboard}{'threadcount'};
				@subboard_lists = split(/\,/, $sblist{"$curboard"});
				foreach $subboard_list (@subboard_lists) {
					my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$subboard_list"});
					my $access = &AccessCheck($subboard_list, '', $subboard_perms);
					if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
					$totalmessagecount{"$curboard"} += ${$uid.$subboard_list}{'messagecount'};
					$totalthreadcount{"$curboard"} += ${$uid.$subboard_list}{'threadcount'};
				}

				## determine the true last post on all the boards a user has access to ##
				if ($lastposttime > $lastthreadtime){
					$lsdatetime = &timeformat($lastposttime);
					$lsposter = ${$uid.$curboard}{'lastposter'};
					$lssub = ${$uid.$curboard}{'lastsubject'};
					&ToChars($lssub);
					$lspostid = ${$uid.$curboard}{'lastpostid'};
					$lsreply = ${$uid.$curboard}{'lastreply'};
					$lastthreadtime = $lastposttime;
				}
			}
			foreach my $boardinfo (@goodboards) {
				chomp $boardinfo;
				my ($testcat);
				($testcat,$curboard)=split(/\|/,$boardinfo);	

				if ($testcat ne $catid){next;}
				## as we fill the vars based on all boards we need to skip any cat already shown before ##

				if (${$uid.$curboard}{'ann'} == 1) {${$uid.$curboard}{'pic'} = "ann.gif";}
				if (${$uid.$curboard}{'rbin'} == 1) {${$uid.$curboard}{'pic'} = "recycle.gif";}
				($sboardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
				&ToChars($sboardname);
				$INFO{'zeropost'} = 0; $zero = "";
				## hide the actual global announcement board for all normal users but admins and gmods ##
				if ($annboard eq $curboard && !$iamadmin && !$iamgmod) {next;}
				## hide the actual recycle bin board for all normal users but admins ##
				if ($annboard eq $curboard && $iamguest && !$iamadmin) {next;}
				$sbdpic = ${$uid.$curboard}{'pic'};
				$bddescr = ${$uid.$curboard}{'description'};
				&ToChars($bddescr);
				$bdmods = ${$uid.$curboard}{'mods'};
				$bdmods =~ s/\, /\,/g;
				$bdmods =~ s/\ /\,/g;
				%moderators = ();
				foreach $curuser (split(/\,/, $bdmods)) {
					&LoadUser($curuser);
					$moderators{$curuser} = ${$uid.$curuser}{'realname'};
				}
				$showsbmods = '';
				if(scalar keys %moderators == 1) { $showsbmods = qq~$boardindex_txt{'298'}: ~; }
				elsif(scalar keys %moderators != 0) { $showsbmods = qq~$boardindex_txt{'63'}: ~; }
				while($tmpa = each(%moderators)) {
					&FormatUserName($tmpa);
					$showsbmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmpa}">$moderators{$tmpa}</a>, ~;
				}
				$showsbmods =~ s/, \Z//;

				&LoadUser($username);
				$bdmodgroups = ${$uid.$curboard}{'modgroups'};
				$bdmodgroups =~ s/\, /\,/g;
				%moderatorgroups = ();
				foreach $curgroup (split(/\,/, $bdmodgroups)) {
					if (${$uid.$username}{'position'} eq $curgroup) { $iammod = 1; }
					foreach $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
						chomp $memberaddgroups;
						if ($memberaddgroups eq $curgroup) { $iammod = 1; last; }
					}
					($thismodgrp, undef) = split(/\|/, $NoPost{$curgroup}, 2);
					$moderatorgroups{$curgroup} = $thismodgrp;
				}

				$showsbmodgroups = '';
				if(scalar keys %moderatorgroups == 1) { $showsbmodgroups = qq~$boardindex_txt{'298a'}: ~; }
				elsif(scalar keys %moderatorgroups != 0) { $showsbmodgroups = qq~$boardindex_txt{'63a'}: ~; }
				while($tmpa = each(%moderatorgroups)) {
					$showsbmodgroups .= qq~$moderatorgroups{$tmpa}, ~;
				}
				$showsbmodgroups =~ s/, \Z//;

				if ($sboard{"$curboard"} ne "") {
					my @subboard = split(/\,/, $sboard{"$curboard"});
					$commacount = 1;
					$subboardlist = "";
					foreach $sub (@subboard) {
						my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$sub"});
						my $access = &AccessCheck($sub, '', $subboard_perms);
						if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
						if ($commacount++ == 1) {
							$subboardlist .= qq~<a href="$scripturl?board=$sub" class="nav">$subboard_name</a>~;
						} else {
							$subboardlist .= qq~, <a href="$scripturl?board=$sub" class="nav">$subboard_name</a>~;
						}
					}
					if ( $subboardlist ne "" ) {
						$subcount = @subboard;
						if ($subcount == 1) { $subboards = "$subboard_txt{'6'}: $subboardlist"; }
						else {$subboards = "$subboard_txt{'7'}: $subboardlist"; }
					} else { $subboards = ""; }
				} else { $subboards = ""; }

				if($showsbmodgroups eq "" && $showsbmods eq "" && $subboards eq "") { $subboards = qq~<br />~; }
				if($showsbmodgroups eq "" && $showsbmods ne "" && $subboards ne "") { $showsbmods .= qq~<br />~; }
				if($showsbmodgroups ne "" && $showsbmods ne "" && $subboards eq "") { $showsbmods .= qq~<br />~; }
				if($showsbmodgroups ne "" && $showsbmods eq "" && $subboards ne "") { $showsbmodgroups .= qq~<br />~; }
				if($showsbmodgroups ne "" && $showsbmods ne "" && $subboards ne "") { $showsbmods .= qq~<br />~; $showsbmodgroups .= qq~<br />~; }

				my $dlp = $yyuserlog{$curboard} ? $yyuserlog{$curboard} : 0;
				if( $max_log_days_old && ${$uid.$curboard}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$curboard} && ($dlp>$max_log_days_old*86400 || $dlp eq 0)) {
					$new = qq~<img src="$imagesdir/on.gif" alt="$boardindex_txt{'333'}" border="0" />~;
				}
				else { $new = qq~<img src="$imagesdir/off.gif" alt="$boardindex_txt{'334'}" border="0" />~; }
				@subboard_lists = split(/\,/, $sblist{"$curboard"});
				foreach $subboardlist (@subboard_lists) {
					my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$subboardlist"});
					my $access = &AccessCheck($subboard_list, '', $subboard_perms);
					if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
					my $dlp = $yyuserlog{$subboardlist} ? $yyuserlog{$subboardlist} : 0;
					$lastpostrealtime{$subboardlist} = ${$uid.$subboardlist}{'lastposttime'} eq 'N/A' || ! ${$uid.$subboardlist}{'lastposttime'} ? '' : ${$uid.$subboardlist}{'lastposttime'};
					if( $max_log_days_old && ${$uid.$subboardlist}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$subboardlist} && ($dlp>$max_log_days_old*86400 || $dlp eq 0)) {
						$new = qq~<img src="$imagesdir/on.gif" alt="$boardindex_txt{'333'}" border="0" />~; last;
					}
				}
				if (${$uid.$curboard}{'ann'} == 1) {$new = qq~<img src="$imagesdir/ann.gif" alt="" border="0" />~;}
				if (${$uid.$curboard}{'rbin'} == 1) {$new = qq~<img src="$imagesdir/recycle.gif" alt="" border="0" />~;}
				$lastposter = ${$uid.$curboard}{'lastposter'};
				unless( $lastposterguest{$curboard} || ${$uid.$curboard}{'lastposter'} eq $boardindex_txt{'470'} ) {
					&LoadUser($lastposter);
					$registrationdate = ${$uid.$lastposter}{'regtime'};

					# No Need to open up each threadid.txt JUST to get last post time..
					# It's stored in forum.totals!
					#fopen (MNUM, "$datadir/${$uid.$curboard}{'lastpostid'}.txt");
					#@threadlist = <MNUM>; 
					#($dummy, $dummy, $dummy, $messagedate, $dummy) =  split(/\|/, $threadlist[${$uid.$curboard}{'lastreply'}],5);
					#fclose (MNUM);
						$messagedate = ${$uid.$curboard}{'lastposttime'};
						if((${$uid.$lastposter}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$lastposter}{'status'} eq "Administrator" || ${$uid.$lastposter}{'status'} eq "Global Moderator") { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposter">${$uid.$lastposter}{'realname'}</a>~; }
					else { $lastposter .= qq~ - $boardindex_txt{'470a'}~; }
				}
				${$uid.$curboard}{'lastposter'} ||= $boardindex_txt{'470'};
				${$uid.$curboard}{'lastposttime'} ||= $boardindex_txt{'470'};

				if ($sbdpic =~ /\//i) {$sbdpic = qq~ <img src="$sbdpic" alt="" border="0" align="middle" /> ~;}
				elsif ($sbdpic) {$sbdpic = qq~ <img src="$imagesdir/$sbdpic" alt="" border="0" align="middle" /> ~;}

				my $templateblock = $subboardblock;
				if (${$uid.$curboard}{'lastreply'} ne "") {
					$lastpostlink = qq~<a href="$scripturl?num=${$uid.$curboard}{'lastpostid'}/${$uid.$curboard}{'lastreply'}#${$uid.$curboard}{'lastreply'}">$img{'lastpost'}</a> $lastposttime{$curboard}~;
				} else {
					$lastpostlink = qq~$img{'lastpost'} $boardindex_txt{'470'}~;
				}

				if(!$topiccut){$topiccut = 15;}
				my $lasttopictxt = ${$uid.$curboard}{'lastsubject'};
				$lasttopictxt =~ s/\A\[m\]/$maintxt{'758'}/;

				&LoadCensorList;	# Load Censor List
				# Censor subjects
				$lasttopictxt = &Censor($lasttopictxt);
				&ToChars($lasttopictxt);

				$convertstr = $lasttopictxt;
				$convertcut = $topiccut;
				&FromHTML($convertstr);
				&CountChars;
				my $lasttopictxt = $convertstr;
				&ToChars($lasttopictxt);

				if ($cliped){$lasttopictxt .= "...";}

				$lasttopictxt =~ s/  / \&nbsp;/g;
				$lasttopictxt =~ s/</&lt;/g;
				$lasttopictxt =~ s/>/&gt;/g;
				$lasttopictxt =~ s/\|/\&#124;/g;

				# Determine last post in subboards
				if ($sboard{"$curboard"} ne "") {
					$sblastpost = 0;
					@allsboards = split(/\,/, $sblist{"$curboard"});
					foreach $sb (@allsboards) {
						my ($sboardname, $sboardperms, $sboardview) = split(/\|/, $board{"$sb"});
						my $access = &AccessCheck($sb, '', $sboardperms);
						if (!$iamadmin && $access ne "granted" && $sboardview != 1) { next; }

						(@sbparents) = split(/\|/, $pboards{"$sb"});
						my ($spboardname, $spboardperms, $spboardview) = split(/\|/, $board{"$sbparents[-1]"});
						my $parentaccess = &AccessCheck("$sbparents[-1]", '', $spboardperms);
						if (!$iamadmin && $access ne "granted" && $parentaccess ne "granted") { next; }

						if (${$uid.$sb}{'lastposttime'} eq "") { next; }
						if (!$iammodhere && !$iamadmin && !$iamgmod) {
							fopen(MNUM, "$boardsdir/$sb.txt");
							@threadlist = <MNUM>;
							fclose(MNUM);
							my (@messarr) = split(/\|/, $threadlist[0]);
							$messagestate = pop(@messarr);
							if ($messagestate =~ /h/i) {
								${$uid.$sb}{'lastpostid'}   = "";
								${$uid.$sb}{'lastsubject'}  = "";
								${$uid.$sb}{'lastreply'}    = "";
								${$uid.$sb}{'lastposter'}   = qq~$boardindex_txt{'470'}~;
								${$uid.$sb}{'lastposttime'} = 0;
								$lastposttime{$sb} = qq~$boardindex_txt{'470'}~;
								for ($i = 1; $i < @threadlist; $i++) {
									($messageid, $messagesubject, undef, undef, undef, undef, undef, undef, $messagestate) = split(/\|/, $threadlist[$i]);
									if ($messagestate !~ /h/i) {
										fopen(MDATA, "$datadir/$messageid.ctb");
										@threaddata = <MDATA>;
										fclose(MDATA);
										chomp @threaddata;
										${$uid.$sb}{'lastpostid'}   = $messageid;
										${$uid.$sb}{'lastsubject'}  = $messagesubject;
										${$uid.$sb}{'lastreply'}    = $threaddata[1];
										${$uid.$sb}{'lastposter'}   = $threaddata[3];
										${$uid.$sb}{'lastposttime'} = $threaddata[4];
										$lastposttime{$sb} = &timeformat($threaddata[4]);
										last;
									}
								}
							}
						}
						if (${$uid.$sb}{'lastposttime'} > $sblastpost) {
							$sbdatetime     = $lastposttime{$sb};
							$sblastposter   = ${$uid.$sb}{'lastposter'};
							$sblastpostsub  = ${$uid.$sb}{'lastsubject'};
							$sblastpostid   = ${$uid.$sb}{'lastpostid'};
							$sblastreply    = ${$uid.$sb}{'lastreply'};
							$sblastpost     = ${$uid.$sb}{'lastposttime'};
							$sblastpostbd   = $sb;
						}
					}
					$sblastposter = ${$uid.$sblastpostbd}{'lastposter'};
					$sblastposter =~ s~\AGuest-(.*)~$1~i;

					if (${$uid.$sblastpostbd}{'lastposttime'} != 0) { $lastposttime{$sblastpostbd} = &timeformat(${$uid.$sblastpostbd}{'lastposttime'}); }
					else { $lastposttime{$sblastpostbd} = $boardindex_txt{'470'}; }

					unless ($lastposterguest{$sblastpostbd} || ${$uid.$sblastpostbd}{'lastposter'} eq $boardindex_txt{'470'}) {
						&LoadUser($sblastposter);
						$registrationdate = ${$uid.$sblastposter}{'regtime'};

						$sbmessagedate = ${$uid.$sblastpostbd}{'lastposttime'};

						if ((${$uid.$sblastposter}{'regdate'} && $sbmessagedate > $registrationdate) || ${$uid.$sblastposter}{'status'} eq "Administrator" || ${$uid.$sblastposter}{'status'} eq "Global Moderator") {
							$sblastposter = qq~<a href="$scripturl?action=viewprofile;username=$sblastposter">${$uid.$sblastposter}{'realname'}</a>~;
						} else {
							$sblastposter .= qq~ - $boardindex_txt{'470a'}~;
						}
					}
					${$uid.$sblastpostbd}{'lastposter'}   ||= $boardindex_txt{'470'};
					${$uid.$sblastpostbd}{'lastposttime'} ||= $boardindex_txt{'470'};
					if (!$topiccut) { $topiccut = 15; }
					my $sblasttopictxt = ${$uid.$sblastpostbd}{'lastsubject'};
					$sblasttopictxt =~ s/\A\[m\]/$maintxt{'758'}/;

					# Censor the subject
					&LoadCensorList;
					$sblasttopictxt = &Censor($sblasttopictxt);
					$sbfulltopictext = qq~$sblasttopictxt~;

					if (${$uid.$sblastpostbd}{'lastreply'} ne "") {
						$sblastpostlink = qq~<a href="$scripturl?num=${$uid.$sblastpostbd}{'lastpostid'}/${$uid.$sblastpostbd}{'lastreply'}#${$uid.$sblastpostbd}{'lastreply'}">$img{'lastpost'}</a> $lastposttime{$sblastpostbd}~;
					} else {
						$sblastpostlink = qq~$img{'lastpost'} $boardindex_txt{'470'}~;
					}

					$convertstr = $sblasttopictxt;
					$convertcut = $topiccut;
					&FromHTML($convertstr);
					&CountChars;
					my $sblasttopictxt = $convertstr;
					&ToChars($sblasttopictxt);
					&ToChars($sbfulltopictext);

					if ($cliped) { $sblasttopictxt .= "..."; }

					$sblasttopictxt =~ s/  / \&nbsp;/g;
					$sblasttopictxt =~ s/</&lt;/g;
					$sblasttopictxt =~ s/>/&gt;/g;
					$sblasttopictxt =~ s/\|/\&#124;/g;

					$sbfulltopictext =~ s/</&lt;/g;
					$sbfulltopictext =~ s/>/&gt;/g;
					$sbfulltopictext =~ s/\|/\&#124;/g;

					$sblasttopicsubject = $sblasttopictxt;
				}

				if ($sboard{"$curboard"} ne "" && $sblastpost > ${$uid.$curboard}{'lastposttime'}) {
					$lasttopiclink = qq~<a href="$scripturl?num=${$uid.$sblastpostbd}{'lastpostid'}/${$uid.$sblastpostbd}{'lastreply'}#${$uid.$sblastpostbd}{'lastreply'}" title="$sbfulltopictext">$sblasttopicsubject</a>~;
					$lastposter = $sblastposter;
					$lastpostlink = $sblastpostlink;
				} else {
					$lasttopiclink = qq~<a href="$scripturl?num=${$uid.$curboard}{'lastpostid'}/${$uid.$curboard}{'lastreply'}#${$uid.$curboard}{'lastreply'}" title="$fulltopictext">$lasttopictxt</a>~;
				}

				if(${$uid.$curboard}{'threadcount'}<0){${$uid.$curboard}{'threadcount'} = 0;}
				if(${$uid.$curboard}{'messagecount'}<0){${$uid.$curboard}{'messagecount'} = 0;}
				$templateblock =~ s/<yabb boardanchor>/$curboard/g;
				$templateblock =~ s/<yabb boardurl>/$scripturl\?board\=$curboard/g;
				$templateblock =~ s/<yabb new>/$new/g;
				$templateblock =~ s/<yabb sboardpic>/$sbdpic/g;
				$templateblock =~ s/<yabb boardname>/$sboardname/g;
				$templateblock =~ s/<yabb boarddesc>/$bddescr/g;
				$templateblock =~ s/<yabb sbmoderators>/$showsbmods$showsbmodgroups/g;
				$templateblock =~ s/<yabb subboards>/$subboards/g;
				$templateblock =~ s/<yabb threadcount>/$totalthreadcount{"$curboard"}/g;
				$templateblock =~ s/<yabb messagecount>/$totalmessagecount{"$curboard"}/g;
				$templateblock =~ s/<yabb lastpostlink>/$lastpostlink/g;
				$templateblock =~ s/<yabb lastposter>/$lastposter/g;
				$templateblock =~ s/<yabb lasttopiclink>/$lasttopiclink/g;

				$subblock .= $templateblock;
			}

			$showsubboards = "$subboardtitle$subboardheader$subblock$subboardfooter";
		}
	} else { $showsubboards = ""; }
	if ($pboard{"$currentboard"} ne "") {
		my @parents = ();
		@parents = split(/\|/, $pboard{"$currentboard"});
		$parentboards = "";
		foreach $parent (@parents) {
			($parent_name, $trash, $trash) = split(/\|/, $board{"$parent"});
			$parentboards .= qq~<a href="$scripturl?board=$parent" class="nav">$parent_name</a>$parentseparator~;
		}
	} else { $parentboards = ""; }
</add before>

<search for>
	$messageindex_template =~ s/<yabb board>/$boardlink/g;
</search for>

<add before>
	$messageindex_template =~ s/<yabb parentboards>/$parentboards/g;
</add before>

<search for>
	$messageindex_template =~ s/<yabb moderators>/$template_mods/g;
</search for>

<add after>
	$messageindex_template =~ s/<yabb subboardblock>/$showsubboards/g;
</add after>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
			if ($board eq $currentboard) { $selecthtml .= "<option selected=\"selected\" value=\"?board=$board\">=> $boardname</option>\n"; }
			else { $selecthtml .= "<option value=\"?board=$board\">&nbsp; - $boardname</option>\n"; }
</search for>

<replace>
			$level = 0;
			&CalcIcon;
			if ($board eq $currentboard) { $selecthtml .= "<option selected=\"selected\" value=\"?board=$board\">=> $boardname</option>\n"; }
			else { $selecthtml .= "<option value=\"?board=$board\">&nbsp; - $boardname</option>\n"; }
			if ($sboard{"$board"} ne "") {
				$subboards = $sboard{"$board"};
				$level++;
				&CalcSubBoards_Subs1;
			}
</replace>

<search for>
			if ($board ne $currentboard) {
				$boardlist .= qq~<option value="$board">$boardname</option>\n~;
			}
</search for>

<replace>
			$level = 0;
			&CalcIcon;
			$boardlist .= qq~<option value="$board">$boardname</option>\n~;
			if ($sboard{"$board"} ne "") {
				$subboards = $sboard{"$board"};
				$level++;
				&CalcSubBoards_Subs2;
			}
</replace>

<search for>
sub Write_ForumMaster {
	fopen(FORUMMASTER, ">$boardsdir/forum.master", 1);
	print FORUMMASTER qq~\$mloaded = 1;\n~;
	@catorder = &undupe(@categoryorder);
	print FORUMMASTER qq~\@categoryorder = qw(@catorder);\n~;
	while (($key, $value) = each(%cat)) {

		# Escape membergroups with a $ in them
		$value =~ s~\$~\\\$~g;
		# Strip membergroups with a ~ from them
		$value =~ s/\~//g;
		print FORUMMASTER qq~\$cat{'$key'} = qq\~$value\~;\n~;
	}
	while (($key, $value) = each(%catinfo)) {

		# Escape membergroups with a $ in them
		$value =~ s~\$~\\\$~g;
		# Strip membergroups with a ~ from them
		$value =~ s/\~//g;
		print FORUMMASTER qq~\$catinfo{'$key'} = qq\~$value\~;\n~;
	}
	while (($key, $value) = each(%board)) {

		# Escape membergroups with a $ in them
		$value =~ s~\$~\\\$~g;
		# Strip membergroups with a ~ from them
		$value =~ s/\~//g;
		print FORUMMASTER qq~\$board{'$key'} = qq\~$value\~;\n~;
	}
	print FORUMMASTER qq~\n1;~;
	fclose(FORUMMASTER);
}
</search for>

<replace>
sub Write_ForumMaster {
	fopen(FORUMMASTER, ">$boardsdir/forum.master", 1);	
   	print FORUMMASTER qq~\$mloaded = 1;\n~;
	@catorder = &undupe(@categoryorder);
	print FORUMMASTER qq~\@categoryorder = qw(@catorder);\n~;
	while (($key, $value) = each(%cat)) {

		# Escape membergroups with a $ in them
		$value =~ s~\$~\\\$~g;
		# Strip membergroups with a ~ from them
		$value =~ s/\~//g;
		print FORUMMASTER qq~\$cat{'$key'} = "$value";\n~;
	}
	while (($key, $value) = each(%catinfo)) {

		# Escape membergroups with a $ in them
		$value =~ s~\$~\\\$~g;
		# Strip membergroups with a ~ from them
		$value =~ s/\~//g;
		print FORUMMASTER qq~\$catinfo{'$key'} = "$value";\n~;
	}
	print FORUMMASTER qq~\n~;
	while (($key, $value) = each(%board)) {

		# Escape membergroups with a $ in them
		$value =~ s~\$~\\\$~g;
		# Strip membergroups with a ~ from them
		$value =~ s/\~//g;
		print FORUMMASTER qq~\$board{'$key'} = "$value";\n~;
	}
	print FORUMMASTER qq~\n~;
	while (($key, $value) = each(%pboard)) {

		# Escape membergroups with a $ in them
		$value =~ s~\$~\\\$~g;
		# Strip membergroups with a ~ from them
		$value =~ s/\~//g;
		print FORUMMASTER qq~\$pboard{'$key'} = "$value";\n~;
	}
	print FORUMMASTER qq~\n~;
	while (($key, $value) = each(%sboard)) {

		# Escape membergroups with a $ in them
		$value =~ s~\$~\\\$~g;
		# Strip membergroups with a ~ from them
		$value =~ s/\~//g;
		print FORUMMASTER qq~\$sboard{'$key'} = "$value";\n~;
	}
	print FORUMMASTER qq~\n~;
	while (($key, $value) = each(%catbdlist)) {

		# Escape membergroups with a $ in them
		$value =~ s~\$~\\\$~g;
		# Strip membergroups with a ~ from them
		$value =~ s/\~//g;
		print FORUMMASTER qq~\$catbdlist{'$key'} = "$value";\n~;
	}
	print FORUMMASTER qq~\n~;
	while (($key, $value) = each(%sblist)) {

		# Escape membergroups with a $ in them
		$value =~ s~\$~\\\$~g;
		# Strip membergroups with a ~ from them
		$value =~ s/\~//g;
		print FORUMMASTER qq~\$sblist{'$key'} = "$value";\n~;
	}
	print FORUMMASTER qq~\n1;~;
	fclose(FORUMMASTER);
}
</replace>

<search for>
1;
</search for>

<add before>
sub CalcSubBoards_Subs1 {
	@boardarray = split(/\,/, $subboards);
	$board_count{"$level"} = @boardarray;
	$board_list{"$level"} = $subboards;
	$boardcount = 0;
	while ($boardcount < $board_count{"$level"}) {
		$cur_board_id = $boardarray[$boardcount];
		($board_name, $board_perms, $board_view) = split(/\|/, $board{"$cur_board_id"});
		&ToChars($board_name);
		my $access = &AccessCheck($cur_board_id, '', $board_perms);
		if (!$iamadmin && $access ne "granted" && $board_view != 1) { $boardcount++; next; }

		if ($cur_board_id eq $currentboard) {
			$level--;
			&CalcIcon;
			$selecthtml .= "<option selected=\"selected\" value=\"?board=$cur_board_id\">&nbsp; $icon=> $board_name</option>\n";
			$level++;
		} else {
			&CalcIcon;
			$selecthtml .= "<option value=\"?board=$cur_board_id\">&nbsp; $icon- $board_name</option>\n";
		}

		if ($sboard{"$cur_board_id"} ne "") {
			$count_store[$level] = $boardcount;
			$subboards = $sboard{"$cur_board_id"};
			$level++;
			&CalcSubBoards_Subs1;
			$level--;
			@boardarray = split(/\,/, $board_list{"$level"});
			$boardcount = $count_store[$level];
		}
		$boardcount++;
	}
}

sub CalcSubBoards_Subs2 {
	@boardarray = split(/\,/, $subboards);
	$board_count{"$level"} = @boardarray;
	$board_list{"$level"} = $subboards;
	$boardcount = 0;
	while ($boardcount < $board_count{"$level"}) {
		$cur_board_id = $boardarray[$boardcount];
		($board_name, $board_perms, $board_view) = split(/\|/, $board{"$cur_board_id"});
		&ToChars($board_name);
		my $access = &AccessCheck($cur_board_id, '', $board_perms);
		if (!$iamadmin && $access ne "granted" && $board_view != 1) { $boardcount++; next; }

		&CalcIcon;
		$boardlist .= qq~<option value="$cur_board_id">$icon$board_name</option>\n~;

		if ($sboard{"$cur_board_id"} ne "") {
			$count_store[$level] = $boardcount;
			$subboards = $sboard{"$cur_board_id"};
			$level++;
			&CalcSubBoards_Subs2;
			$level--;
			@boardarray = split(/\,/, $board_list{"$level"});
			$boardcount = $count_store[$level];
		}
		$boardcount++;
	}
}

sub CalcIcon {
	my $start = $level;
	$icon = "";
	while ($start > 0) {
		$icon .= "- ";
		$start--;
	}
}



</add before>

<edit file>
Sources/Recent.pl
</edit file>

<search for>
sub RecentPosts {
	&spam_protection;
	my $display = $INFO{'display'} ||= 10;
	my (@memset, @categories, %data, $numfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify);

	$numfound = 0;

	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
	foreach $catid (@categoryorder) {
		$boardlist = $cat{$catid};

		(@bdlist) = split(/\,/, $boardlist);
		($catname, $catperms) = split(/\|/, $catinfo{"$catid"});
		$cataccess = &CatAccess($catperms);
		if (!$cataccess) { next; }

		foreach $curboard (@bdlist) {
			($boardname{$curboard}, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});

			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted") { next; }

			$catname{$curboard} = $catname;

			fopen(REC_BDTXT, "$boardsdir/$curboard.txt");
			for ($i = 0; $i < $display && ($buffer = <REC_BDTXT>); $i++) {
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split(/\|/, $buffer);
				unless ($tstate =~ /h/) {
					$mtime = $tdate;
					$data[$numfound] = "$mtime|$curboard|$tnum|$treplies|$tusername|$tname|$tstate";
					$numfound++;
				}
			}
			fclose(REC_BDTXT);
		}
	}
</search for>

<replace>
sub RecentPosts {
	&spam_protection;
	my $display = $INFO{'display'} ||= 10;
	my (@memset, @categories, %data, $numfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify);
	$subboard_list = "";

	$numfound = 0;

	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
	foreach $catid (@categoryorder) {
		$boardlist = $cat{$catid};

		(@bdlist) = split(/\,/, $boardlist);
		($catname, $catperms) = split(/\|/, $catinfo{"$catid"});
		$cataccess = &CatAccess($catperms);
		if (!$cataccess) { next; }

		foreach $curboard (@bdlist) {
			($boardname{$curboard}, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});

			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted") { next; }

			$catname{$curboard} = $catname;

			fopen(REC_BDTXT, "$boardsdir/$curboard.txt");
			for ($i = 0; $i < $display && ($buffer = <REC_BDTXT>); $i++) {
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split(/\|/, $buffer);
				unless ($tstate =~ /h/) {
					$mtime = $tdate;
					$data[$numfound] = "$mtime|$curboard|$tnum|$treplies|$tusername|$tname|$tstate";
					$numfound++;
				}
			}
			fclose(REC_BDTXT);
			if ($sboard{"$curboard"} ne "") {
				if ($subboard_list eq "") { $subboard_list .= qq~$sboard{"$curboard"}~; }
				else { $subboard_list .= qq~,$sboard{"$curboard"}~; }
			}
		}
	}
	@subboards_array = split(/\,/, $subboard_list);
	&CalcSubBoards_Recent1;
	$datanum = $numfound;
	$subdisp = $display;
	&CalcSubBoards_Recent2;
	@catname = %catname;
	@sbcatname = %sbcatname;
	push(@catname, @sbcatname);
	%catname = @catname;
</replace>

<search for>
		$message = &Censor($message);
		$msub    = &Censor($msub);
		&wrap;
		if ($enable_ubbc) {
			$ns = $mns;
			if (!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
			&DoUBBC;
		}
		&wrap2;
		&ToChars($msub);
		&ToChars($message);
		&ToChars($boardname{$board});
		$msub =~ s/\A\[m\]/$maintxt{'758'}/;

		if ($enable_notification) { $notify = qq~$menusep<a href="$scripturl?board=$board;action=notify;thread=$tnum/$startnum">$img{'notify'}</a>~; }
		$mdate = &timeformat($mdate);
		$yymain .= qq~
<table border="0" width="100%" cellspacing="1" class="bordercolor" style="table-layout: fixed;">
  <tr>
    <td width="5%" align="center" class="titlebg">$counter</td>
    <td width="95%" class="titlebg">&nbsp;$catname{$board} / $boardname{$board} / <a href="$scripturl?num=$tnum/$c#$c"><u>$msub</u></a><br />
    &nbsp;<span class="small">$maintxt{'30'}: $mdate&nbsp;</span></td>
</search for>

<replace>
		$parents = "";
		if ($pboard{"$board"} ne "") {
			@pboards = split(/\|/, $pboard{"$board"});
			foreach $pbd (@pboards) {
				($pbdname, $boardperms, $boardview) = split(/\|/, $board{"$pbd"});
				$parents .= qq~$pbdname / ~;
			}
		}

		$message = &Censor($message);
		$msub    = &Censor($msub);
		&wrap;
		if ($enable_ubbc) {
			$ns = $mns;
			if (!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
			&DoUBBC;
		}
		&wrap2;
		&ToChars($msub);
		&ToChars($message);
		&ToChars($boardname{$board});
		$msub =~ s/\A\[m\]/$maintxt{'758'}/;

		if ($enable_notification) { $notify = qq~$menusep<a href="$scripturl?board=$board;action=notify;thread=$tnum/$startnum">$img{'notify'}</a>~; }
		$mdate = &timeformat($mdate);
		$yymain .= qq~
<table border="0" width="100%" cellspacing="1" class="bordercolor" style="table-layout: fixed;">
  <tr>
    <td width="5%" align="center" class="titlebg">$counter</td>
    <td width="95%" class="titlebg">&nbsp;$catname{$board} / $parents$boardname{$board} / <a href="$scripturl?num=$tnum/$c#$c"><u>$msub</u></a><br />
    &nbsp;<span class="small">$maintxt{'30'}: $mdate&nbsp;</span></td>
</replace>

<search for>
1;
</search for>

<add before>
sub CalcSubBoards_Recent1 {
	$sbds = "";
	foreach $sbd (@subboards_array) {
		if ($sboard{"$sbd"} ne "") {
			$subboard_list .= qq~,$sboard{"$sbd"}~;
			$sbds .= qq~$sboard{"$sbd"},~;
		}
	}
	if ($sbds ne "") {
		chop ($sbds);
		@subboards_array = split(/\,/, $sbds);
		&CalcSubBoards_Recent1;
	}
}

sub CalcSubBoards_Recent2 {
	(@sbdlist) = split(/\,/, $subboard_list);
	foreach $cursubboard (@sbdlist) {
		($boardname{$cursubboard}, $boardperms, $boardview) = split(/\|/, $board{"$cursubboard"});

		my $access = &AccessCheck($cursubboard, '', $boardperms);
		if (!$iamadmin && $access ne "granted") { next; }

		$sbcat = ${$uid.$cursubboard}{'cat'};
		($catname, $catperms) = split(/\|/, $catinfo{"$sbcat"});
		$sbcatname{$cursubboard} = $catname;

		fopen(REC_BDTXT, "$boardsdir/$cursubboard.txt");
		for ($i = 0; $i < $subdisp && ($buffer = <REC_BDTXT>); $i++) {
			($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split(/\|/, $buffer);
			unless ($tstate =~ /h/) {
				$mtime = $tdate;
				$data[$datanum] = "$mtime|$cursubboard|$tnum|$treplies|$tusername|$tname|$tstate";
				$datanum++;
			}
		}
		fclose(REC_BDTXT);
	}
}

</add before>

<edit file>
Sources/Search.pl
</edit file>

<search for>
		foreach $curboard (@bdlist) {
			($boardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
			&ToChars($boardname);
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted") { next; }

			# Checks to see if category is expanded or collapsed
			if ($username ne "Guest") {
				if ($catcol{$catid}) {
					$selected = qq~selected="selected"~;
					$isselected++;
				} else {
					$selected = "";
				}
			} else {
				$selected = qq~selected="selected"~;
				$isselected++;
			}
			$allselected++;
			$checklist .= qq~<option value="$curboard" $selected>$boardname</option>\n          ~;
</search for>

<add after>
			if ($sboard{"$curboard"} ne "") {
				$subboards = $sboard{"$curboard"};
				$level = 1;
				&CalcSubBoards_Search1;
			}
</add after>

<search for>
	foreach $catid (@categoryorder) {
		$boardlist = $cat{$catid};
		(@bdlist) = split(/\,/, $boardlist);
		($catname, $catperms) = split(/\|/, $catinfo{"$catid"});
		$cataccess = &CatAccess($catperms);
		if (!$cataccess) { next; }

		foreach $cboard (@bdlist) {
			($bname, $bperms, $bview) = split(/\|/, $board{"$cboard"});
			$catname{$cboard} = $catname;
		}
	}
</search for>

<replace>
	foreach $catid (@categoryorder) {
		$boardlist = $catbdlist{$catid};
		(@bdlist) = split(/\,/, $boardlist);
		($catname, $catperms) = split(/\|/, $catinfo{"$catid"});
		$cataccess = &CatAccess($catperms);
		if (!$cataccess) { next; }

		foreach $cboard (@bdlist) {
			($bname, $bperms, $bview) = split(/\|/, $board{"$cboard"});
			$catname{$cboard} = $catname;
		}
	}
</replace>

<search for>
  boardcheck: foreach $curboard (@boards) {
		($boardname{$curboard}, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});

		my $access = &AccessCheck($curboard, '', $boardperms);
		if (!$iamadmin && $access ne "granted") { next; }

		fopen(FILE, "$boardsdir/$curboard.txt") || next;
		@threads = <FILE>;
		fclose(FILE);
</search for>

<replace>
  boardcheck: foreach $curboard (@boards) {
		($boardname{$curboard}, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});

		my $access = &AccessCheck($curboard, '', $boardperms);
		if (!$iamadmin && $access ne "granted") { next; }

		$parentboards{"$curboard"} = "";
		if ($pboard{"$curboard"} ne "") {
			@parents = split(/\|/, $pboard{"$curboard"});
			foreach $parent (@parents) {
				($boardname{$parent}, $boardperms, $boardview) = split(/\|/, $board{"$parent"});
				$parentboards{"$curboard"} .= "$boardname{$parent} / ";
			}
		}

		fopen(FILE, "$boardsdir/$curboard.txt") || next;
		@threads = <FILE>;
		fclose(FILE);
</replace>

<search for>
    <td align="left" width="95%" class="titlebg"><span class="text1"><b>&nbsp;$catname{$board} / $boardname{$board} / <a href="$scripturl?num=$tnum/$msgnum#$msgnum"><span class="text1"><u>$msub</u></span></a></b></span><br />
</search for>

<replace>
    <td align="left" width="95%" class="titlebg"><span class="text1"><b>&nbsp;$catname{$board} / $parentboards{$board}$boardname{$board} / <a href="$scripturl?num=$tnum/$msgnum#$msgnum"><span class="text1"><u>$msub</u></span></a></b></span><br />
</replace>

<search for>
1;
</search for>

<add before>
sub CalcSubBoards_Search1 {
	@boardarray = split(/\,/, $subboards);
	$board_count{"$level"} = @boardarray;
	$board_list{"$level"} = $subboards;
	$boardcount = 0;
	while ($boardcount < $board_count{"$level"}) {
		$cursubboard = $boardarray[$boardcount];
		($boardname, $boardperms, $boardview) = split(/\|/, $board{"$cursubboard"});
		&ToChars($boardname);
		my $access = &AccessCheck($cursubboard, '', $boardperms);
		if (!$iamadmin && $access ne "granted") { $boardcount++; next; }

		&CalcIcon;
		$checklist .= qq~<option value="$cursubboard" $selected>$icon$boardname</option>\n          ~;
		if ($sboard{"$cursubboard"} ne "") {
			$count_store[$level] = $boardcount;
			$subboards = $sboard{"$cursubboard"};
			$level++;
			&CalcSubBoards_Search1;
			$level--;
			@boardarray = split(/\,/, $board_list{"$level"});
			$boardcount = $count_store[$level];
		}
		$boardcount++;
	}
}
</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
		$boardlist = $cat{$catid};
</search for>

<replace>
		$boardlist = $catbdlist{$catid};
</replace>

<search for>
		$displayname = $mname;
</search for>

<add after>
		$parents = "";
		if ($pboard{"$board"} ne "") {
			@pboards = split(/\|/, $pboard{"$board"});
			foreach $pbd (@pboards) {
				($pbdname, $boardperms, $boardview) = split(/\|/, $board{"$pbd"});
				$parents .= qq~$pbdname / ~;
			}
		}
</add after>

<search for>
    <td width="95%" class="titlebg"><span class="text1"><b>&nbsp;$catname{$board} / $boardname{$board} / <a href="$scripturl?num=$tnum/$c#$c"><span class="text1" ><u>$msub</u></span></a></b></span><br />
</search for>

<replace>
    <td width="95%" class="titlebg"><span class="text1"><b>&nbsp;$catname{$board} / $parents$boardname{$board} / <a href="$scripturl?num=$tnum/$c#$c"><span class="text1" ><u>$msub</u></span></a></b></span><br />
</replace>

<edit file>
Templates/default/BoardIndex.template
</edit file>

<search for>
	<td class="windowbg2" width="55%" align="left"><a name="<yabb boardanchor>" href="<yabb boardurl>"><yabb boardpic><b><yabb boardname></b></a><br /><yabb boarddesc><br /><br /><span class="small"><i><yabb moderators></i></span></td>
</search for>

<replace>
	<td class="windowbg2" width="55%" align="left"><a name="<yabb boardanchor>" href="<yabb boardurl>"><yabb boardpic><b><yabb boardname></b></a><br /><yabb boarddesc><br /><br /><span class="small"><i><yabb moderators></i></span><span class="small"><i><yabb subboards></i></span></td>
</replace>

<edit file>
Templates/default/Display.template
</edit file>

<search for>
		<b><yabb home>  <yabb category>  <yabb board></b> <yabb moderators>
</search for>

<replace>
		<b><yabb home>  <yabb category>  <yabb parentboards><yabb board></b> <yabb moderators>
</replace>

<search for>
		<b><yabb home>  <yabb category>  <yabb board></b> <yabb moderators>
</search for>

<replace>
		<b><yabb home>  <yabb category>  <yabb parentboards><yabb board></b> <yabb moderators>
</replace>

<search for>
1;
</search for>

<add before>
$parentseparator = " - ";

</add before>

<edit file>
Templates/default/MessageIndex.template
</edit file>

<search for>
<!-- Navigation Bar start -->

<span class="small"><b><yabb home>  <yabb category>  <yabb board></b> <yabb moderators></span>

<!-- Navigation Bar end -->
</search for>

<replace>
<!-- Navigation Bar start -->

<span class="small"><b><yabb home>  <yabb category>  <yabb parentboards><yabb board></b> <yabb moderators></span>

<!-- Navigation Bar end -->
</replace>

<search for>
	  <span class="small"><b><yabb home>  <yabb category>  <yabb board></b> <yabb moderators></span>
</search for>

<replace>
	  <span class="small"><b><yabb home>  <yabb category>  <yabb parentboards><yabb board></b> <yabb moderators></span>
</replace>

<search for>
<!-- Navigation Bar end -->

</search for>

<add after>
<!-- Sub-Board block start, should be left as is -->

<yabb subboardblock>

<!-- Sub-Board block end, should be left as is -->
</add after>

<search for>
1;
</search for>

<add before>
$subboardtitle = qq~
<!-- Sub-Board Title Bar start -->

<div class="seperator">
<table cellpadding="4" cellspacing="1" border="0" width="100%">
<tr>
	<td class="titlebg" colspan="2" width="60%">
		$boardindex_txt{'20'}
	</td>
	<td class="titlebg" width="24%" align="center">
		$boardindex_txt{'22'}
	</td>
	<td class="titlebg" width="8%" align="center">
		$boardindex_txt{'330'}
	</td>
	<td class="titlebg" width="8%" align="center">
		$boardindex_txt{'21'}
	</td>
</tr>
</table>
</div><br />

<!-- Sub-Board Title Bar end -->
~;

$subboardheader = qq~
<div class="boardcontainer">
<table cellpadding="4" cellspacing="1" border="0" width="100%">
~;

$subboardblock = qq~
<tr>
	<td class="windowbg" width="5%" align="center" valign="top"><yabb new></td>
	<td class="windowbg2" width="55%" align="left"><a name="<yabb boardanchor>" href="<yabb boardurl>"><yabb sboardpic><b><yabb boardname></b></a><br /><yabb boarddesc><br /><br /><span class="small"><i><yabb sbmoderators></i></span><span class="small"><i><yabb subboards></i></span></td>
	<td class="windowbg" valign="middle" align="left" width="24%">
	<span class="small" style="float: left; margin-left: 12px;">
	<yabb lastpostlink><br />
	<b>$boardindex_txt{'524'}:</b> <yabb lasttopiclink><br />
	<b>$boardindex_txt{'525'}:</b> <yabb lastposter>
	</span>
	</td>
	<td class="windowbg2" valign="middle" align="center" width="8%"><yabb threadcount></td>
	<td class="windowbg2" valign="middle" align="center" width="8%"><yabb messagecount></td>
</tr>
~;

$subboardfooter = qq~
</table>
</div><br />
~;

$parentseparator = " - ";
</add before>